/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 36 "../../../gdb/gdb/c-exp.y"


#include "defs.h"
#include <ctype.h>
#include "expression.h"
#include "value.h"
#include "parser-defs.h"
#include "language.h"
#include "c-lang.h"
#include "c-support.h"
#include "bfd.h" /* Required by objfiles.h.  */
#include "symfile.h" /* Required by objfiles.h.  */
#include "objfiles.h" /* For have_full_symbols and have_partial_symbols */
#include "charset.h"
#include "block.h"
#include "cp-support.h"
#include "macroscope.h"
#include "objc-lang.h"
#include "typeprint.h"
#include "cp-abi.h"
#include "type-stack.h"

#define parse_type(ps) builtin_type (ps->gdbarch ())

/* Remap normal yacc parser interface names (yyparse, yylex, yyerror,
   etc).  */
#define GDB_YY_REMAP_PREFIX c_
#include "yy-remap.h"

/* The state of the parser, used internally when we are parsing the
   expression.  */

static struct parser_state *pstate = NULL;

/* Data that must be held for the duration of a parse.  */

struct c_parse_state
{
  /* These are used to hold type lists and type stacks that are
     allocated during the parse.  */
  std::vector<std::unique_ptr<std::vector<struct type *>>> type_lists;
  std::vector<std::unique_ptr<struct type_stack>> type_stacks;

  /* Storage for some strings allocated during the parse.  */
  std::vector<gdb::unique_xmalloc_ptr<char>> strings;

  /* When we find that lexptr (the global var defined in parse.c) is
     pointing at a macro invocation, we expand the invocation, and call
     scan_macro_expansion to save the old lexptr here and point lexptr
     into the expanded text.  When we reach the end of that, we call
     end_macro_expansion to pop back to the value we saved here.  The
     macro expansion code promises to return only fully-expanded text,
     so we don't need to "push" more than one level.

     This is disgusting, of course.  It would be cleaner to do all macro
     expansion beforehand, and then hand that to lexptr.  But we don't
     really know where the expression ends.  Remember, in a command like

     (gdb) break *ADDRESS if CONDITION

     we evaluate ADDRESS in the scope of the current frame, but we
     evaluate CONDITION in the scope of the breakpoint's location.  So
     it's simply wrong to try to macro-expand the whole thing at once.  */
  const char *macro_original_text = nullptr;

  /* We save all intermediate macro expansions on this obstack for the
     duration of a single parse.  The expansion text may sometimes have
     to live past the end of the expansion, due to yacc lookahead.
     Rather than try to be clever about saving the data for a single
     token, we simply keep it all and delete it after parsing has
     completed.  */
  auto_obstack expansion_obstack;

  /* The type stack.  */
  struct type_stack type_stack;
};

/* This is set and cleared in c_parse.  */

static struct c_parse_state *cpstate;

int yyparse (void);

static int yylex (void);

static void yyerror (const char *);

static int type_aggregate_p (struct type *);


#line 162 "c-exp.c.tmp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTRPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTRPTR nullptr
#   else
#    define YY_NULLPTRPTR 0
#   endif
#  else
#   define YY_NULLPTRPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    INT = 258,                     /* INT  */
    FLOAT = 259,                   /* FLOAT  */
    STRING = 260,                  /* STRING  */
    NSSTRING = 261,                /* NSSTRING  */
    SELECTOR = 262,                /* SELECTOR  */
    CHAR = 263,                    /* CHAR  */
    NAME = 264,                    /* NAME  */
    UNKNOWN_CPP_NAME = 265,        /* UNKNOWN_CPP_NAME  */
    COMPLETE = 266,                /* COMPLETE  */
    TYPENAME = 267,                /* TYPENAME  */
    CLASSNAME = 268,               /* CLASSNAME  */
    OBJC_LBRAC = 269,              /* OBJC_LBRAC  */
    NAME_OR_INT = 270,             /* NAME_OR_INT  */
    OPERATOR = 271,                /* OPERATOR  */
    STRUCT = 272,                  /* STRUCT  */
    CLASS = 273,                   /* CLASS  */
    UNION = 274,                   /* UNION  */
    ENUM = 275,                    /* ENUM  */
    SIZEOF = 276,                  /* SIZEOF  */
    ALIGNOF = 277,                 /* ALIGNOF  */
    UNSIGNED = 278,                /* UNSIGNED  */
    COLONCOLON = 279,              /* COLONCOLON  */
    TEMPLATE = 280,                /* TEMPLATE  */
    ERROR = 281,                   /* ERROR  */
    NEW = 282,                     /* NEW  */
    DELETE = 283,                  /* DELETE  */
    REINTERPRET_CAST = 284,        /* REINTERPRET_CAST  */
    DYNAMIC_CAST = 285,            /* DYNAMIC_CAST  */
    STATIC_CAST = 286,             /* STATIC_CAST  */
    CONST_CAST = 287,              /* CONST_CAST  */
    ENTRY = 288,                   /* ENTRY  */
    TYPEOF = 289,                  /* TYPEOF  */
    DECLTYPE = 290,                /* DECLTYPE  */
    TYPEID = 291,                  /* TYPEID  */
    SIGNED_KEYWORD = 292,          /* SIGNED_KEYWORD  */
    LONG = 293,                    /* LONG  */
    SHORT = 294,                   /* SHORT  */
    INT_KEYWORD = 295,             /* INT_KEYWORD  */
    CONST_KEYWORD = 296,           /* CONST_KEYWORD  */
    VOLATILE_KEYWORD = 297,        /* VOLATILE_KEYWORD  */
    DOUBLE_KEYWORD = 298,          /* DOUBLE_KEYWORD  */
    DOLLAR_VARIABLE = 299,         /* DOLLAR_VARIABLE  */
    ASSIGN_MODIFY = 300,           /* ASSIGN_MODIFY  */
    TRUEKEYWORD = 301,             /* TRUEKEYWORD  */
    FALSEKEYWORD = 302,            /* FALSEKEYWORD  */
    ABOVE_COMMA = 303,             /* ABOVE_COMMA  */
    OROR = 304,                    /* OROR  */
    ANDAND = 305,                  /* ANDAND  */
    EQUAL = 306,                   /* EQUAL  */
    NOTEQUAL = 307,                /* NOTEQUAL  */
    LEQ = 308,                     /* LEQ  */
    GEQ = 309,                     /* GEQ  */
    LSH = 310,                     /* LSH  */
    RSH = 311,                     /* RSH  */
    UNARY = 312,                   /* UNARY  */
    INCREMENT = 313,               /* INCREMENT  */
    DECREMENT = 314,               /* DECREMENT  */
    ARROW = 315,                   /* ARROW  */
    ARROW_STAR = 316,              /* ARROW_STAR  */
    DOT_STAR = 317,                /* DOT_STAR  */
    BLOCKNAME = 318,               /* BLOCKNAME  */
    FILENAME = 319,                /* FILENAME  */
    DOTDOTDOT = 320                /* DOTDOTDOT  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define INT 258
#define FLOAT 259
#define STRING 260
#define NSSTRING 261
#define SELECTOR 262
#define CHAR 263
#define NAME 264
#define UNKNOWN_CPP_NAME 265
#define COMPLETE 266
#define TYPENAME 267
#define CLASSNAME 268
#define OBJC_LBRAC 269
#define NAME_OR_INT 270
#define OPERATOR 271
#define STRUCT 272
#define CLASS 273
#define UNION 274
#define ENUM 275
#define SIZEOF 276
#define ALIGNOF 277
#define UNSIGNED 278
#define COLONCOLON 279
#define TEMPLATE 280
#define ERROR 281
#define NEW 282
#define DELETE 283
#define REINTERPRET_CAST 284
#define DYNAMIC_CAST 285
#define STATIC_CAST 286
#define CONST_CAST 287
#define ENTRY 288
#define TYPEOF 289
#define DECLTYPE 290
#define TYPEID 291
#define SIGNED_KEYWORD 292
#define LONG 293
#define SHORT 294
#define INT_KEYWORD 295
#define CONST_KEYWORD 296
#define VOLATILE_KEYWORD 297
#define DOUBLE_KEYWORD 298
#define DOLLAR_VARIABLE 299
#define ASSIGN_MODIFY 300
#define TRUEKEYWORD 301
#define FALSEKEYWORD 302
#define ABOVE_COMMA 303
#define OROR 304
#define ANDAND 305
#define EQUAL 306
#define NOTEQUAL 307
#define LEQ 308
#define GEQ 309
#define LSH 310
#define RSH 311
#define UNARY 312
#define INCREMENT 313
#define DECREMENT 314
#define ARROW 315
#define ARROW_STAR 316
#define DOT_STAR 317
#define BLOCKNAME 318
#define FILENAME 319
#define DOTDOTDOT 320

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 132 "../../../gdb/gdb/c-exp.y"

    LONGEST lval;
    struct {
      LONGEST val;
      struct type *type;
    } typed_val_int;
    struct {
      gdb_byte val[16];
      struct type *type;
    } typed_val_float;
    struct type *tval;
    struct stoken sval;
    struct typed_stoken tsval;
    struct ttype tsym;
    struct symtoken ssym;
    int voidval;
    const struct block *bval;
    enum exp_opcode opcode;

    struct stoken_vector svec;
    std::vector<struct type *> *tvec;

    struct type_stack *type_stack;

    struct objc_class_str theclass;
  

#line 370 "c-exp.c.tmp"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);


/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_INT = 3,                        /* INT  */
  YYSYMBOL_FLOAT = 4,                      /* FLOAT  */
  YYSYMBOL_STRING = 5,                     /* STRING  */
  YYSYMBOL_NSSTRING = 6,                   /* NSSTRING  */
  YYSYMBOL_SELECTOR = 7,                   /* SELECTOR  */
  YYSYMBOL_CHAR = 8,                       /* CHAR  */
  YYSYMBOL_NAME = 9,                       /* NAME  */
  YYSYMBOL_UNKNOWN_CPP_NAME = 10,          /* UNKNOWN_CPP_NAME  */
  YYSYMBOL_COMPLETE = 11,                  /* COMPLETE  */
  YYSYMBOL_TYPENAME = 12,                  /* TYPENAME  */
  YYSYMBOL_CLASSNAME = 13,                 /* CLASSNAME  */
  YYSYMBOL_OBJC_LBRAC = 14,                /* OBJC_LBRAC  */
  YYSYMBOL_NAME_OR_INT = 15,               /* NAME_OR_INT  */
  YYSYMBOL_OPERATOR = 16,                  /* OPERATOR  */
  YYSYMBOL_STRUCT = 17,                    /* STRUCT  */
  YYSYMBOL_CLASS = 18,                     /* CLASS  */
  YYSYMBOL_UNION = 19,                     /* UNION  */
  YYSYMBOL_ENUM = 20,                      /* ENUM  */
  YYSYMBOL_SIZEOF = 21,                    /* SIZEOF  */
  YYSYMBOL_ALIGNOF = 22,                   /* ALIGNOF  */
  YYSYMBOL_UNSIGNED = 23,                  /* UNSIGNED  */
  YYSYMBOL_COLONCOLON = 24,                /* COLONCOLON  */
  YYSYMBOL_TEMPLATE = 25,                  /* TEMPLATE  */
  YYSYMBOL_ERROR = 26,                     /* ERROR  */
  YYSYMBOL_NEW = 27,                       /* NEW  */
  YYSYMBOL_DELETE = 28,                    /* DELETE  */
  YYSYMBOL_REINTERPRET_CAST = 29,          /* REINTERPRET_CAST  */
  YYSYMBOL_DYNAMIC_CAST = 30,              /* DYNAMIC_CAST  */
  YYSYMBOL_STATIC_CAST = 31,               /* STATIC_CAST  */
  YYSYMBOL_CONST_CAST = 32,                /* CONST_CAST  */
  YYSYMBOL_ENTRY = 33,                     /* ENTRY  */
  YYSYMBOL_TYPEOF = 34,                    /* TYPEOF  */
  YYSYMBOL_DECLTYPE = 35,                  /* DECLTYPE  */
  YYSYMBOL_TYPEID = 36,                    /* TYPEID  */
  YYSYMBOL_SIGNED_KEYWORD = 37,            /* SIGNED_KEYWORD  */
  YYSYMBOL_LONG = 38,                      /* LONG  */
  YYSYMBOL_SHORT = 39,                     /* SHORT  */
  YYSYMBOL_INT_KEYWORD = 40,               /* INT_KEYWORD  */
  YYSYMBOL_CONST_KEYWORD = 41,             /* CONST_KEYWORD  */
  YYSYMBOL_VOLATILE_KEYWORD = 42,          /* VOLATILE_KEYWORD  */
  YYSYMBOL_DOUBLE_KEYWORD = 43,            /* DOUBLE_KEYWORD  */
  YYSYMBOL_DOLLAR_VARIABLE = 44,           /* DOLLAR_VARIABLE  */
  YYSYMBOL_ASSIGN_MODIFY = 45,             /* ASSIGN_MODIFY  */
  YYSYMBOL_TRUEKEYWORD = 46,               /* TRUEKEYWORD  */
  YYSYMBOL_FALSEKEYWORD = 47,              /* FALSEKEYWORD  */
  YYSYMBOL_48_ = 48,                       /* ','  */
  YYSYMBOL_ABOVE_COMMA = 49,               /* ABOVE_COMMA  */
  YYSYMBOL_50_ = 50,                       /* '='  */
  YYSYMBOL_51_ = 51,                       /* '?'  */
  YYSYMBOL_OROR = 52,                      /* OROR  */
  YYSYMBOL_ANDAND = 53,                    /* ANDAND  */
  YYSYMBOL_54_ = 54,                       /* '|'  */
  YYSYMBOL_55_ = 55,                       /* '^'  */
  YYSYMBOL_56_ = 56,                       /* '&'  */
  YYSYMBOL_EQUAL = 57,                     /* EQUAL  */
  YYSYMBOL_NOTEQUAL = 58,                  /* NOTEQUAL  */
  YYSYMBOL_59_ = 59,                       /* '<'  */
  YYSYMBOL_60_ = 60,                       /* '>'  */
  YYSYMBOL_LEQ = 61,                       /* LEQ  */
  YYSYMBOL_GEQ = 62,                       /* GEQ  */
  YYSYMBOL_LSH = 63,                       /* LSH  */
  YYSYMBOL_RSH = 64,                       /* RSH  */
  YYSYMBOL_65_ = 65,                       /* '@'  */
  YYSYMBOL_66_ = 66,                       /* '+'  */
  YYSYMBOL_67_ = 67,                       /* '-'  */
  YYSYMBOL_68_ = 68,                       /* '*'  */
  YYSYMBOL_69_ = 69,                       /* '/'  */
  YYSYMBOL_70_ = 70,                       /* '%'  */
  YYSYMBOL_UNARY = 71,                     /* UNARY  */
  YYSYMBOL_INCREMENT = 72,                 /* INCREMENT  */
  YYSYMBOL_DECREMENT = 73,                 /* DECREMENT  */
  YYSYMBOL_ARROW = 74,                     /* ARROW  */
  YYSYMBOL_ARROW_STAR = 75,                /* ARROW_STAR  */
  YYSYMBOL_76_ = 76,                       /* '.'  */
  YYSYMBOL_DOT_STAR = 77,                  /* DOT_STAR  */
  YYSYMBOL_78_ = 78,                       /* '['  */
  YYSYMBOL_79_ = 79,                       /* '('  */
  YYSYMBOL_BLOCKNAME = 80,                 /* BLOCKNAME  */
  YYSYMBOL_FILENAME = 81,                  /* FILENAME  */
  YYSYMBOL_DOTDOTDOT = 82,                 /* DOTDOTDOT  */
  YYSYMBOL_83_ = 83,                       /* ')'  */
  YYSYMBOL_84_ = 84,                       /* '!'  */
  YYSYMBOL_85_ = 85,                       /* '~'  */
  YYSYMBOL_86_ = 86,                       /* ']'  */
  YYSYMBOL_87_ = 87,                       /* ':'  */
  YYSYMBOL_88_ = 88,                       /* '{'  */
  YYSYMBOL_89_ = 89,                       /* '}'  */
  YYSYMBOL_YYACCEPT = 90,                  /* $accept  */
  YYSYMBOL_start = 91,                     /* start  */
  YYSYMBOL_type_exp = 92,                  /* type_exp  */
  YYSYMBOL_exp1 = 93,                      /* exp1  */
  YYSYMBOL_exp = 94,                       /* exp  */
  YYSYMBOL_95_1 = 95,                      /* $@1  */
  YYSYMBOL_96_2 = 96,                      /* $@2  */
  YYSYMBOL_97_3 = 97,                      /* $@3  */
  YYSYMBOL_msglist = 98,                   /* msglist  */
  YYSYMBOL_msgarglist = 99,                /* msgarglist  */
  YYSYMBOL_msgarg = 100,                   /* msgarg  */
  YYSYMBOL_101_4 = 101,                    /* $@4  */
  YYSYMBOL_102_5 = 102,                    /* $@5  */
  YYSYMBOL_lcurly = 103,                   /* lcurly  */
  YYSYMBOL_arglist = 104,                  /* arglist  */
  YYSYMBOL_function_method = 105,          /* function_method  */
  YYSYMBOL_function_method_void = 106,     /* function_method_void  */
  YYSYMBOL_function_method_void_or_typelist = 107, /* function_method_void_or_typelist  */
  YYSYMBOL_rcurly = 108,                   /* rcurly  */
  YYSYMBOL_string_exp = 109,               /* string_exp  */
  YYSYMBOL_block = 110,                    /* block  */
  YYSYMBOL_variable = 111,                 /* variable  */
  YYSYMBOL_qualified_name = 112,           /* qualified_name  */
  YYSYMBOL_space_identifier = 113,         /* space_identifier  */
  YYSYMBOL_const_or_volatile = 114,        /* const_or_volatile  */
  YYSYMBOL_cv_with_space_id = 115,         /* cv_with_space_id  */
  YYSYMBOL_const_or_volatile_or_space_identifier_noopt = 116, /* const_or_volatile_or_space_identifier_noopt  */
  YYSYMBOL_const_or_volatile_or_space_identifier = 117, /* const_or_volatile_or_space_identifier  */
  YYSYMBOL_ptr_operator = 118,             /* ptr_operator  */
  YYSYMBOL_119_6 = 119,                    /* $@6  */
  YYSYMBOL_120_7 = 120,                    /* $@7  */
  YYSYMBOL_ptr_operator_ts = 121,          /* ptr_operator_ts  */
  YYSYMBOL_abs_decl = 122,                 /* abs_decl  */
  YYSYMBOL_direct_abs_decl = 123,          /* direct_abs_decl  */
  YYSYMBOL_array_mod = 124,                /* array_mod  */
  YYSYMBOL_func_mod = 125,                 /* func_mod  */
  YYSYMBOL_type = 126,                     /* type  */
  YYSYMBOL_typebase = 127,                 /* typebase  */
  YYSYMBOL_type_name = 128,                /* type_name  */
  YYSYMBOL_parameter_typelist = 129,       /* parameter_typelist  */
  YYSYMBOL_nonempty_typelist = 130,        /* nonempty_typelist  */
  YYSYMBOL_ptype = 131,                    /* ptype  */
  YYSYMBOL_conversion_type_id = 132,       /* conversion_type_id  */
  YYSYMBOL_conversion_declarator = 133,    /* conversion_declarator  */
  YYSYMBOL_const_and_volatile = 134,       /* const_and_volatile  */
  YYSYMBOL_const_or_volatile_noopt = 135,  /* const_or_volatile_noopt  */
  YYSYMBOL_oper = 136,                     /* oper  */
  YYSYMBOL_field_name = 137,               /* field_name  */
  YYSYMBOL_name = 138,                     /* name  */
  YYSYMBOL_name_not_typename = 139         /* name_not_typename  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 159 "../../../gdb/gdb/c-exp.y"

/* YYSTYPE gets defined by %union */
static int parse_number (struct parser_state *par_state,
			 const char *, int, int, YYSTYPE *);
static struct stoken operator_stoken (const char *);
static struct stoken typename_stoken (const char *);
static void check_parameter_typelist (std::vector<struct type *> *);
static void write_destructor_name (struct parser_state *par_state,
				   struct stoken);

#ifdef YYBISON
static void c_print_token (FILE *file, int type, YYSTYPE value);
#define YYPRINT(FILE, TYPE, VALUE) c_print_token (FILE, TYPE, VALUE)
#endif

#line 549 "c-exp.c.tmp"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or xmalloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined xmalloc) \
             && (defined YYFREE || defined xfree)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC xmalloc
#   if ! defined xmalloc && ! defined EXIT_SUCCESS
void *xmalloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE xfree
#   if ! defined xfree && ! defined EXIT_SUCCESS
void xfree (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  171
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1732

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  90
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  50
/* YYNRULES -- Number of rules.  */
#define YYNRULES  275
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  432

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   320


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    84,     2,     2,     2,    70,    56,     2,
      79,    83,    68,    66,    48,    67,    76,    69,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    87,     2,
      59,    50,    60,    51,    65,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    78,     2,    86,    55,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    88,    54,    89,    85,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    49,    52,    53,    57,    58,    61,    62,
      63,    64,    71,    72,    73,    74,    75,    77,    80,    81,
      82
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   277,   277,   278,   281,   285,   289,   295,   302,   303,
     308,   312,   316,   320,   324,   328,   332,   336,   340,   344,
     348,   352,   356,   360,   364,   370,   377,   387,   393,   400,
     408,   412,   418,   425,   435,   441,   448,   456,   460,   464,
     474,   473,   498,   497,   514,   513,   522,   524,   527,   528,
     531,   533,   535,   542,   539,   553,   563,   562,   588,   592,
     595,   599,   603,   624,   636,   643,   644,   647,   655,   658,
     665,   669,   673,   679,   683,   687,   691,   695,   699,   703,
     707,   711,   715,   719,   723,   727,   731,   735,   739,   743,
     747,   751,   755,   759,   763,   770,   777,   786,   799,   806,
     809,   815,   822,   841,   846,   850,   854,   861,   878,   896,
     929,   938,   946,   956,   964,   970,   983,   998,  1017,  1030,
    1054,  1063,  1064,  1094,  1172,  1179,  1180,  1183,  1186,  1187,
    1191,  1192,  1197,  1196,  1200,  1199,  1202,  1204,  1206,  1208,
    1212,  1219,  1221,  1222,  1225,  1227,  1235,  1243,  1250,  1258,
    1260,  1262,  1264,  1268,  1273,  1285,  1299,  1301,  1304,  1307,
    1310,  1313,  1316,  1319,  1322,  1325,  1328,  1331,  1334,  1337,
    1340,  1343,  1346,  1349,  1352,  1355,  1358,  1361,  1364,  1367,
    1370,  1373,  1376,  1379,  1384,  1389,  1394,  1400,  1406,  1411,
    1417,  1423,  1428,  1434,  1440,  1444,  1449,  1455,  1458,  1461,
    1464,  1470,  1475,  1477,  1481,  1482,  1489,  1496,  1506,  1508,
    1517,  1526,  1533,  1534,  1541,  1545,  1546,  1549,  1550,  1553,
    1557,  1559,  1563,  1565,  1567,  1569,  1571,  1573,  1575,  1577,
    1579,  1581,  1583,  1585,  1587,  1589,  1591,  1593,  1595,  1597,
    1599,  1601,  1641,  1643,  1645,  1647,  1649,  1651,  1653,  1655,
    1657,  1659,  1661,  1663,  1665,  1667,  1669,  1671,  1673,  1696,
    1697,  1698,  1699,  1700,  1701,  1702,  1705,  1706,  1707,  1708,
    1709,  1710,  1713,  1714,  1722,  1735
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "INT", "FLOAT",
  "STRING", "NSSTRING", "SELECTOR", "CHAR", "NAME", "UNKNOWN_CPP_NAME",
  "COMPLETE", "TYPENAME", "CLASSNAME", "OBJC_LBRAC", "NAME_OR_INT",
  "OPERATOR", "STRUCT", "CLASS", "UNION", "ENUM", "SIZEOF", "ALIGNOF",
  "UNSIGNED", "COLONCOLON", "TEMPLATE", "ERROR", "NEW", "DELETE",
  "REINTERPRET_CAST", "DYNAMIC_CAST", "STATIC_CAST", "CONST_CAST", "ENTRY",
  "TYPEOF", "DECLTYPE", "TYPEID", "SIGNED_KEYWORD", "LONG", "SHORT",
  "INT_KEYWORD", "CONST_KEYWORD", "VOLATILE_KEYWORD", "DOUBLE_KEYWORD",
  "DOLLAR_VARIABLE", "ASSIGN_MODIFY", "TRUEKEYWORD", "FALSEKEYWORD", "','",
  "ABOVE_COMMA", "'='", "'?'", "OROR", "ANDAND", "'|'", "'^'", "'&'",
  "EQUAL", "NOTEQUAL", "'<'", "'>'", "LEQ", "GEQ", "LSH", "RSH", "'@'",
  "'+'", "'-'", "'*'", "'/'", "'%'", "UNARY", "INCREMENT", "DECREMENT",
  "ARROW", "ARROW_STAR", "'.'", "DOT_STAR", "'['", "'('", "BLOCKNAME",
  "FILENAME", "DOTDOTDOT", "')'", "'!'", "'~'", "']'", "':'", "'{'", "'}'",
  "$accept", "start", "type_exp", "exp1", "exp", "$@1", "$@2", "$@3",
  "msglist", "msgarglist", "msgarg", "$@4", "$@5", "lcurly", "arglist",
  "function_method", "function_method_void",
  "function_method_void_or_typelist", "rcurly", "string_exp", "block",
  "variable", "qualified_name", "space_identifier", "const_or_volatile",
  "cv_with_space_id", "const_or_volatile_or_space_identifier_noopt",
  "const_or_volatile_or_space_identifier", "ptr_operator", "$@6", "$@7",
  "ptr_operator_ts", "abs_decl", "direct_abs_decl", "array_mod",
  "func_mod", "type", "typebase", "type_name", "parameter_typelist",
  "nonempty_typelist", "ptype", "conversion_type_id",
  "conversion_declarator", "const_and_volatile", "const_or_volatile_noopt",
  "oper", "field_name", "name", "name_not_typename", YY_NULLPTRPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    44,   303,
      61,    63,   304,   305,   124,    94,    38,   306,   307,    60,
      62,   308,   309,   310,   311,    64,    43,    45,    42,    47,
      37,   312,   313,   314,   315,   316,    46,   317,    91,    40,
     318,   319,   320,    41,    33,   126,    93,    58,   123,   125
};
#endif

#define YYPACT_NINF (-226)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-127)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     488,  -226,  -226,  -226,  -226,   -64,  -226,  -226,   -54,     4,
     660,  -226,   907,   139,   243,   254,   271,   746,   -27,   182,
      27,    81,    -1,    15,    26,    35,    -8,    24,    34,   263,
     288,   202,  -226,    78,    89,  -226,  -226,  -226,  -226,   832,
     832,   832,   832,   832,   832,   488,   114,  -226,   832,   832,
    -226,   145,  -226,   105,  1308,   402,   172,  -226,   176,   158,
     177,  -226,  -226,   141,  -226,  1689,  -226,   146,   282,  -226,
     151,  -226,   184,    81,  -226,    47,     4,  -226,  1308,  -226,
     137,    21,    30,  -226,  -226,  -226,  -226,  -226,  -226,  -226,
    -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,
    -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,   143,   148,
    -226,  -226,   276,  -226,  -226,  -226,  -226,  -226,  -226,  -226,
    -226,   222,  -226,   225,  -226,   227,  -226,   229,     4,   488,
     216,  1657,  -226,    11,   201,  -226,  -226,  -226,  -226,  -226,
     189,  1657,  1657,  1657,  1657,   574,   832,   488,    86,  -226,
    -226,   211,   220,   239,  -226,  -226,   238,   244,  -226,  -226,
    -226,   216,   216,   216,   216,   216,   216,   173,    -7,   216,
     216,  -226,   832,   832,   832,   832,   832,   832,   832,   832,
     832,   832,   832,   832,   832,   832,   832,   832,   832,   832,
     832,   832,   832,   832,   832,   832,  -226,  -226,    72,   832,
     234,   832,   832,  1024,   178,  1308,    12,    81,  -226,    81,
     289,   118,   146,  -226,     3,    48,   231,  -226,    14,  1015,
     236,    50,  -226,    55,  -226,  -226,  -226,   214,   832,    81,
     281,    38,    38,    38,  -226,   223,   235,   241,   250,  -226,
    -226,   179,  -226,  -226,  -226,  -226,  -226,   232,   237,   268,
    -226,  -226,  1689,   262,   264,   270,   277,  1063,   259,  1098,
     265,  1133,   305,  -226,  -226,  -226,   306,   309,  -226,  -226,
    -226,   832,  -226,  1308,   -25,  1308,  1308,   944,  1374,  1406,
    1431,  1463,  1488,  1520,  1520,  1545,  1545,  1545,  1545,  1560,
    1560,  1577,  1589,  1589,   216,   216,   216,  -226,     4,  -226,
    -226,  -226,  -226,  -226,  -226,    81,  -226,   341,  -226,    65,
    -226,    81,  -226,   343,    65,   -21,    31,   832,  -226,   272,
     308,  -226,   832,   832,  -226,  -226,   334,  -226,  -226,  -226,
     283,  -226,   236,   236,   146,   287,  -226,  -226,   279,   280,
    -226,    55,   347,  -226,  -226,  -226,    -6,  -226,    81,   832,
     832,   290,    38,  -226,   291,   293,   294,  -226,  -226,  -226,
    -226,  -226,  -226,  -226,  -226,  -226,   314,   296,   298,   302,
     303,  -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,   216,
    -226,   832,   357,  -226,   372,  -226,  -226,  -226,    19,   118,
    1062,   216,  1308,  -226,  -226,  -226,  -226,  -226,  -226,   146,
    -226,  -226,  1308,  1308,  -226,  -226,   291,   832,  -226,  -226,
    -226,   832,   832,   832,   832,  1340,  -226,  -226,  -226,  -226,
    -226,  -226,  -226,  1308,  1168,  1203,  1238,  1273,  -226,  -226,
    -226,  -226
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
     126,    95,    98,   107,   110,     0,    96,   272,   275,   156,
       0,    97,   126,     0,     0,     0,     0,     0,     0,   198,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     158,   159,   157,   220,   221,   183,   100,   111,   112,     0,
       0,     0,     0,     0,     0,   126,   273,   114,     0,     0,
      58,     0,     3,     2,     8,    59,    64,    66,     0,   109,
       0,    99,   121,     0,   128,   126,     4,   212,   155,   219,
     129,   274,   123,     0,    56,     0,    40,    42,    44,   156,
       0,   222,   223,   241,   252,   238,   249,   248,   235,   233,
     234,   244,   245,   239,   240,   246,   247,   242,   243,   228,
     229,   230,   231,   232,   250,   251,   254,   253,     0,     0,
     237,   236,   215,   258,   266,   270,   186,   268,   269,   267,
     271,   185,   189,   188,   192,   191,   195,   194,     0,   126,
      22,   126,   204,   206,   207,   205,   197,   275,   273,   122,
       0,   126,   126,   126,   126,   126,     0,   126,   206,   207,
     199,   166,   162,   167,   160,   184,   181,   179,   177,   217,
     218,    11,    13,    12,    10,    16,    17,     0,     0,    14,
      15,     1,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,    19,     0,     0,
       0,     0,     0,    53,     0,    60,     0,     0,   108,     0,
       0,   126,   202,   203,     0,   138,   136,   134,     0,   126,
     140,   142,   213,   143,   146,   148,   116,     0,    59,     0,
     118,     0,     0,     0,   257,     0,     0,     0,     0,   256,
     255,   215,   214,   187,   190,   193,   196,     0,     0,   173,
     164,   180,   126,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   171,   163,   165,   161,   175,   170,   168,   182,
     178,     0,    72,     9,     0,    94,    93,     0,    91,    90,
      89,    88,    87,    81,    82,    85,    86,    83,    84,    79,
      80,    73,    77,    78,    74,    75,    76,    26,   268,   265,
     264,   262,   263,   261,   260,     0,    29,    24,   259,    30,
      33,     0,    36,    31,    37,     0,    55,    59,   210,     0,
     208,    68,     0,     0,    69,    67,   117,   124,   127,   125,
       0,   150,   139,   137,   131,     0,   149,   153,     0,     0,
     132,   141,   126,   145,   147,   101,     0,   119,     0,     0,
       0,     0,    47,    48,    46,     0,     0,   226,   224,   227,
     225,   132,   216,   102,    23,   174,     0,     0,     0,     0,
       0,     5,     6,     7,    21,    20,   172,   176,   169,    71,
      39,     0,    27,    25,    34,    32,    38,    63,     0,   126,
     126,    70,    61,   152,   130,   135,   151,   144,   154,   131,
      57,   120,    52,    51,    41,    49,     0,     0,    43,    45,
     201,     0,     0,     0,     0,    92,    28,    35,    54,    62,
     209,   211,   133,    50,     0,     0,     0,     0,   103,   105,
     104,   106
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -226,  -226,    66,    13,   -10,  -226,  -226,  -226,   -34,  -226,
      39,  -226,  -226,  -226,  -225,  -226,  -226,  -226,   186,  -226,
    -226,  -226,   -42,  -226,  -199,  -226,   -66,    -4,  -110,  -226,
    -226,  -226,   174,   175,  -219,  -218,  -105,    10,   365,   195,
    -226,  -226,  -226,   159,  -226,  -197,    -5,   199,     5,   393
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    51,   167,   168,    54,   231,   232,   233,   351,   352,
     353,   317,   228,    55,   206,    56,    57,    58,   322,    59,
      60,    61,    62,   211,    63,    64,    65,   395,   220,   399,
     334,   221,   222,   223,   224,   225,    66,    67,   136,   339,
     320,    68,   113,   242,    69,    70,    71,   307,   354,    72
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      78,   213,   241,   346,   343,   344,   330,   130,   120,   120,
     120,   120,   328,    53,   329,    73,   120,   335,   121,   123,
     125,   127,   112,   172,   247,    74,   140,   172,    75,   161,
     162,   163,   164,   165,   166,   235,     7,   137,   169,   170,
     258,   172,   323,    12,   237,   205,   213,   114,   115,   249,
     117,   250,   131,   118,    12,  -126,   114,   115,   141,   117,
     323,   380,   118,    12,   214,   386,    52,   323,   120,   214,
     120,   145,    33,    34,   142,   212,   272,   400,   227,   173,
     230,   114,   115,   297,   298,   143,   349,   118,    12,   331,
     114,   115,   388,   117,   144,   299,   118,    12,   318,   236,
     336,   321,   418,   146,   216,   332,   333,   138,   238,   300,
     301,   302,   303,   147,   318,   304,   217,   387,   119,   329,
     159,   204,   343,   344,   262,   350,   263,   119,   218,   219,
     160,   241,   229,   218,   342,   257,   259,   261,  -113,   198,
     199,   200,   201,   202,   203,   171,   213,   366,   114,   115,
     116,   117,   119,   172,   118,    12,   306,   305,   312,    33,
      34,   119,   273,   208,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   274,    33,    34,   309,
     419,   314,   329,   120,   132,   120,   -65,   248,   355,   356,
     207,   209,   120,   308,   120,   308,   210,   253,   254,   255,
     256,  -126,   325,   260,   326,   315,  -125,   226,   205,   119,
     133,   134,   135,   234,   120,   156,   120,   120,   120,   239,
     173,   240,   215,   243,   347,   216,   244,   318,   245,   157,
     246,   251,   158,   114,   115,   310,   298,   361,   252,   118,
      12,   264,   114,   115,   122,   117,   271,   299,   118,    12,
     265,   379,   266,   114,   115,   124,   117,   321,   394,   118,
      12,   300,   301,   302,   303,   132,   267,   304,   269,   268,
     114,   115,   126,   117,   270,   421,   118,    12,   196,   197,
     198,   199,   200,   201,   202,   203,   214,   345,   327,   217,
     120,   148,   149,   135,   340,   348,   120,   205,   365,   357,
     382,   151,   391,   392,   119,   363,   384,    33,    34,   311,
     364,   358,   367,   119,   368,   152,   153,   359,   154,   215,
     369,   155,   216,   394,   119,   215,   360,   370,   216,   402,
     403,  -126,   372,   120,   217,   376,   377,   120,   374,   378,
     217,   119,   383,   401,   385,   389,   390,   406,  -115,    79,
     218,   219,   397,   398,    13,    14,    15,    16,   416,   393,
      19,   415,    21,   396,   410,   411,   404,   412,   407,   408,
     409,   413,   414,   417,    29,    30,    31,    32,    33,    34,
      35,   405,   324,   338,   150,   422,   341,   423,   319,   313,
     362,   424,   425,   426,   427,     1,     2,     3,     4,     5,
       6,     7,     8,   139,     9,     0,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,     0,     0,
     337,    22,    23,    24,    25,     0,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,     0,    37,    38,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,  -126,    40,    41,
      42,     0,     0,     0,    43,    44,     0,     0,     0,     0,
       0,    45,    46,    47,     0,     0,    48,    49,     0,     0,
      50,     1,     2,     3,     4,     5,     6,     7,     8,     0,
       9,     0,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,     0,     0,     0,    22,    23,    24,
      25,     0,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,     0,    37,    38,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    40,    41,    42,     0,     0,     0,
      43,    44,     0,     0,     0,     0,     0,    45,    46,    47,
       0,     0,    48,    49,     0,     0,    50,     1,     2,     3,
       4,     5,     6,     7,     8,     0,     9,     0,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
       0,     0,     0,    22,    23,    24,    25,     0,     0,     0,
      28,    29,    30,    31,    32,    33,    34,    35,    36,     0,
      37,    38,     0,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      40,    41,    42,     0,     0,     0,    43,    44,     0,     0,
       0,     0,     0,    45,    46,    47,     0,     0,    48,    49,
       0,     0,    50,     1,     2,     3,     4,     5,     6,     7,
       8,     0,    76,    77,    10,    11,    12,     0,     0,     0,
       0,    17,    18,     0,    20,     0,     0,     0,     0,    22,
      23,    24,    25,     0,     0,     0,    28,     0,     0,     0,
       0,     0,     0,     0,    36,     0,    37,    38,     0,     0,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,    41,    42,     0,
       0,     0,    43,    44,     0,     0,     0,     0,     0,    45,
      46,    47,     0,     0,    48,    49,     0,     0,    50,     1,
       2,     3,     4,     5,     6,     7,     8,     0,   128,     0,
      10,    11,    12,     0,     0,     0,     0,    17,    18,     0,
      20,     0,     0,     0,     0,    22,    23,    24,    25,     0,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
      36,     0,    37,    38,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    40,    41,    42,     0,     0,     0,    43,    44,
       0,     0,     0,     0,     0,   129,    46,    47,     0,     0,
      48,    49,     0,     0,    50,     1,     2,     3,     4,     5,
       6,     7,     8,     0,   128,     0,    10,    11,    12,     0,
       0,     0,     0,    17,    18,     0,    20,     0,     0,     0,
       0,    22,    23,    24,    25,     0,     0,     0,    28,     0,
       0,     0,     0,     0,     0,     0,    36,     0,    37,    38,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    40,    41,
      42,     0,     0,     0,    43,    44,     0,     0,     0,     0,
       0,    45,    46,    47,     0,     0,    48,    49,     0,    79,
      50,    80,     0,     0,    13,    14,    15,    16,     0,     0,
      19,     0,    21,     0,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,    29,    30,    31,    32,    33,    34,
      35,     0,    83,     0,     0,    84,     0,    85,   173,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,     0,    99,   100,   101,   102,   103,     0,   104,
     105,   106,   107,     0,     0,   108,   109,     0,     0,   174,
       0,   110,   111,     0,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,     0,   196,   197,   198,   199,
     200,   201,   202,   203,     0,     0,     0,    79,     0,   214,
       0,   381,    13,    14,    15,    16,    79,     0,    19,     0,
      21,    13,    14,    15,    16,     0,     0,    19,     0,    21,
       0,     0,    29,    30,    31,    32,    33,    34,    35,     0,
       0,    29,    30,    31,    32,    33,    34,    35,   215,     0,
       0,   216,     0,     0,    79,     0,     0,   173,     0,    13,
      14,    15,    16,   217,     0,    19,     0,    21,     0,  -126,
       0,     0,     0,   218,   219,     0,     0,     0,   337,    29,
      30,    31,    32,    33,    34,    35,     0,   316,   174,     0,
       0,     0,   173,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,     0,   196,   197,   198,   199,   200,
     201,   202,   203,   174,   420,     0,   371,   173,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,     0,
     196,   197,   198,   199,   200,   201,   202,   203,   174,     0,
       0,   373,   173,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,     0,   196,   197,   198,   199,   200,
     201,   202,   203,   174,     0,     0,   375,   173,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,     0,
     196,   197,   198,   199,   200,   201,   202,   203,   174,     0,
       0,   428,   173,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,     0,   196,   197,   198,   199,   200,
     201,   202,   203,   174,     0,     0,   429,   173,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,     0,
     196,   197,   198,   199,   200,   201,   202,   203,   174,     0,
       0,   430,   173,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,     0,   196,   197,   198,   199,   200,
     201,   202,   203,   174,   173,     0,   431,     0,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,     0,
     196,   197,   198,   199,   200,   201,   202,   203,   173,     0,
       0,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,     0,   196,   197,   198,   199,   200,   201,   202,   203,
     173,     0,     0,     0,     0,     0,     0,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   173,   196,   197,   198,   199,
     200,   201,   202,   203,     0,     0,     0,     0,     0,     0,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   173,   196,   197,
     198,   199,   200,   201,   202,   203,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   173,   196,   197,   198,   199,   200,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,     0,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   173,   196,   197,   198,   199,   200,
     201,   202,   203,     0,     0,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   173,
     196,   197,   198,   199,   200,   201,   202,   203,     0,     0,
       0,     0,     0,     0,   173,     0,     0,     0,     0,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   173,   196,   197,   198,   199,   200,   201,   202,   203,
       0,     0,     0,   173,     0,     0,     0,     0,   188,   189,
     190,   191,   192,   193,   194,   195,     0,   196,   197,   198,
     199,   200,   201,   202,   203,   190,   191,   192,   193,   194,
     195,     0,   196,   197,   198,   199,   200,   201,   202,   203,
       0,     0,     0,   191,   192,   193,   194,   195,     0,   196,
     197,   198,   199,   200,   201,   202,   203,   193,   194,   195,
       0,   196,   197,   198,   199,   200,   201,   202,   203,    79,
       0,     0,     0,     0,    13,    14,    15,    16,     0,     0,
      19,     0,    21,     0,     0,     0,     0,     0,     0,     0,
       0,    26,    27,     0,    29,    30,    31,    32,    33,    34,
      35,    79,     0,     0,     0,     0,    13,    14,    15,    16,
       0,     0,    19,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    29,    30,    31,    32,
      33,    34,    35
};

static const yytype_int16 yycheck[] =
{
      10,    67,   112,   228,   223,   223,     3,    17,    13,    14,
      15,    16,   211,     0,   211,    79,    21,     3,    13,    14,
      15,    16,    12,    48,   129,    79,    21,    48,    24,    39,
      40,    41,    42,    43,    44,    14,     9,    10,    48,    49,
     145,    48,    48,    16,    14,    55,   112,     9,    10,    38,
      12,    40,    79,    15,    16,    24,     9,    10,    59,    12,
      48,    86,    15,    16,    14,    86,     0,    48,    73,    14,
      75,    79,    41,    42,    59,    65,    83,    83,    73,    14,
      75,     9,    10,    11,    12,    59,    48,    15,    16,    86,
       9,    10,   317,    12,    59,    23,    15,    16,   203,    78,
      86,    89,    83,    79,    56,   215,   216,    80,    78,    37,
      38,    39,    40,    79,   219,    43,    68,   316,    80,   316,
      42,    55,   341,   341,    38,    87,    40,    80,    78,    79,
      41,   241,    85,    78,    79,   145,   146,   147,    24,    74,
      75,    76,    77,    78,    79,     0,   212,   252,     9,    10,
      11,    12,    80,    48,    15,    16,   198,    85,   200,    41,
      42,    80,   172,     5,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   173,    41,    42,   199,
     389,   201,   389,   198,    12,   200,    24,   131,   232,   233,
      24,    24,   207,   198,   209,   200,    65,   141,   142,   143,
     144,    65,   207,   147,   209,   202,    65,    33,   228,    80,
      38,    39,    40,    86,   229,    23,   231,   232,   233,    86,
      14,    83,    53,    11,   229,    56,    11,   342,    11,    37,
      11,    40,    40,     9,    10,    11,    12,    68,    59,    15,
      16,    40,     9,    10,    11,    12,    83,    23,    15,    16,
      40,   271,    23,     9,    10,    11,    12,    89,   334,    15,
      16,    37,    38,    39,    40,    12,    37,    43,    40,    40,
       9,    10,    11,    12,    40,   390,    15,    16,    72,    73,
      74,    75,    76,    77,    78,    79,    14,    83,     9,    68,
     305,    38,    39,    40,    68,    24,   311,   317,    40,    86,
     305,    23,   322,   323,    80,    83,   311,    41,    42,    85,
      83,    86,    60,    80,    60,    37,    38,    86,    40,    53,
      60,    43,    56,   399,    80,    53,    86,    60,    56,   349,
     350,    65,    83,   348,    68,    40,    40,   352,    83,    40,
      68,    80,    11,   348,    11,    83,    48,   352,    24,    12,
      78,    79,    83,    83,    17,    18,    19,    20,    11,    86,
      23,   381,    25,    86,    60,    79,    86,    79,    87,    86,
      86,    79,    79,    11,    37,    38,    39,    40,    41,    42,
      43,   352,   206,   219,    29,   399,   221,   407,   203,   200,
     241,   411,   412,   413,   414,     3,     4,     5,     6,     7,
       8,     9,    10,    20,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      83,    29,    30,    31,    32,    -1,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    67,
      68,    -1,    -1,    -1,    72,    73,    -1,    -1,    -1,    -1,
      -1,    79,    80,    81,    -1,    -1,    84,    85,    -1,    -1,
      88,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    29,    30,    31,
      32,    -1,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    67,    68,    -1,    -1,    -1,
      72,    73,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,
      -1,    -1,    84,    85,    -1,    -1,    88,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    29,    30,    31,    32,    -1,    -1,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    67,    68,    -1,    -1,    -1,    72,    73,    -1,    -1,
      -1,    -1,    -1,    79,    80,    81,    -1,    -1,    84,    85,
      -1,    -1,    88,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    16,    -1,    -1,    -1,
      -1,    21,    22,    -1,    24,    -1,    -1,    -1,    -1,    29,
      30,    31,    32,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    -1,    46,    47,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    68,    -1,
      -1,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    79,
      80,    81,    -1,    -1,    84,    85,    -1,    -1,    88,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    -1,
      14,    15,    16,    -1,    -1,    -1,    -1,    21,    22,    -1,
      24,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    -1,    46,    47,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    -1,    -1,    -1,    72,    73,
      -1,    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,
      84,    85,    -1,    -1,    88,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    -1,    14,    15,    16,    -1,
      -1,    -1,    -1,    21,    22,    -1,    24,    -1,    -1,    -1,
      -1,    29,    30,    31,    32,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,    46,    47,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,
      68,    -1,    -1,    -1,    72,    73,    -1,    -1,    -1,    -1,
      -1,    79,    80,    81,    -1,    -1,    84,    85,    -1,    12,
      88,    14,    -1,    -1,    17,    18,    19,    20,    -1,    -1,
      23,    -1,    25,    -1,    27,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    39,    40,    41,    42,
      43,    -1,    45,    -1,    -1,    48,    -1,    50,    14,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    -1,    -1,    78,    79,    -1,    -1,    45,
      -1,    84,    85,    -1,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    77,    78,    79,    -1,    -1,    -1,    12,    -1,    14,
      -1,    87,    17,    18,    19,    20,    12,    -1,    23,    -1,
      25,    17,    18,    19,    20,    -1,    -1,    23,    -1,    25,
      -1,    -1,    37,    38,    39,    40,    41,    42,    43,    -1,
      -1,    37,    38,    39,    40,    41,    42,    43,    53,    -1,
      -1,    56,    -1,    -1,    12,    -1,    -1,    14,    -1,    17,
      18,    19,    20,    68,    -1,    23,    -1,    25,    -1,    65,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    83,    37,
      38,    39,    40,    41,    42,    43,    -1,    83,    45,    -1,
      -1,    -1,    14,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      77,    78,    79,    45,    82,    -1,    83,    14,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    77,    78,    79,    45,    -1,
      -1,    83,    14,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      77,    78,    79,    45,    -1,    -1,    83,    14,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    77,    78,    79,    45,    -1,
      -1,    83,    14,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      77,    78,    79,    45,    -1,    -1,    83,    14,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    77,    78,    79,    45,    -1,
      -1,    83,    14,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      77,    78,    79,    45,    14,    -1,    83,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    77,    78,    79,    14,    -1,
      -1,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    77,    78,    79,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    14,    72,    73,    74,    75,
      76,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    14,    72,    73,
      74,    75,    76,    77,    78,    79,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    14,    72,    73,    74,    75,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    14,    72,    73,    74,    75,    76,
      77,    78,    79,    -1,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    14,
      72,    73,    74,    75,    76,    77,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    14,    72,    73,    74,    75,    76,    77,    78,    79,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    77,    78,    79,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    77,    78,    79,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    77,    78,    79,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    77,    78,    79,    12,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    -1,    -1,
      23,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    12,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      -1,    -1,    23,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,
      41,    42,    43
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    12,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    29,    30,    31,    32,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    46,    47,    56,
      66,    67,    68,    72,    73,    79,    80,    81,    84,    85,
      88,    91,    92,    93,    94,   103,   105,   106,   107,   109,
     110,   111,   112,   114,   115,   116,   126,   127,   131,   134,
     135,   136,   139,    79,    79,    24,    12,    13,    94,    12,
      14,    27,    28,    45,    48,    50,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    66,
      67,    68,    69,    70,    72,    73,    74,    75,    78,    79,
      84,    85,   127,   132,     9,    10,    11,    12,    15,    80,
     136,   138,    11,   138,    11,   138,    11,   138,    12,    79,
      94,    79,    12,    38,    39,    40,   128,    10,    80,   139,
     138,    59,    59,    59,    59,    79,    79,    79,    38,    39,
     128,    23,    37,    38,    40,    43,    23,    37,    40,    42,
      41,    94,    94,    94,    94,    94,    94,    92,    93,    94,
      94,     0,    48,    14,    45,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    72,    73,    74,    75,
      76,    77,    78,    79,    92,    94,   104,    24,     5,    24,
      65,   113,   127,   116,    14,    53,    56,    68,    78,    79,
     118,   121,   122,   123,   124,   125,    33,   138,   102,    85,
     138,    95,    96,    97,    86,    14,    78,    14,    78,    86,
      83,   118,   133,    11,    11,    11,    11,   126,    92,    38,
      40,    40,    59,    92,    92,    92,    92,    94,   126,    94,
      92,    94,    38,    40,    40,    40,    23,    37,    40,    40,
      40,    83,    83,    94,    93,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    11,    12,    23,
      37,    38,    39,    40,    43,    85,   112,   137,   138,    94,
      11,    85,   112,   137,    94,    93,    83,   101,   126,   129,
     130,    89,   108,    48,   108,   138,   138,     9,   114,   135,
       3,    86,   118,   118,   120,     3,    86,    83,   122,   129,
      68,   123,    79,   124,   125,    83,   104,   138,    24,    48,
      87,    98,    99,   100,   138,    98,    98,    86,    86,    86,
      86,    68,   133,    83,    83,    40,   126,    60,    60,    60,
      60,    83,    83,    83,    83,    83,    40,    40,    40,    94,
      86,    87,   138,    11,   138,    11,    86,   114,   104,    83,
      48,    94,    94,    86,   116,   117,    86,    83,    83,   119,
      83,   138,    94,    94,    86,   100,   138,    87,    86,    86,
      60,    79,    79,    79,    79,    94,    11,    11,    83,   114,
      82,   126,   117,    94,    94,    94,    94,    94,    83,    83,
      83,    83
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    90,    91,    91,    92,    92,    92,    92,    93,    93,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      95,    94,    96,    94,    97,    94,    98,    98,    99,    99,
     100,   100,   100,   101,    94,    94,   102,    94,   103,   104,
     104,   104,   105,   106,    94,   107,   107,    94,   108,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,   109,   109,    94,
      94,    94,    94,   110,   110,   110,   111,   111,   112,   112,
     112,   111,   111,   111,   113,   114,   114,   115,   116,   116,
     117,   117,   119,   118,   120,   118,   118,   118,   118,   118,
     121,   122,   122,   122,   123,   123,   123,   123,   123,   124,
     124,   124,   124,   125,   125,   126,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   128,   128,   128,   128,   129,   129,
     130,   130,   131,   131,   132,   133,   133,   134,   134,   135,
     135,   135,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   137,
     137,   137,   137,   137,   137,   137,   138,   138,   138,   138,
     138,   138,   139,   139,   139,   139
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     1,     4,     4,     4,     1,     3,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     4,     2,     4,     3,     4,     3,     4,     5,     3,
       3,     3,     4,     3,     4,     5,     3,     3,     4,     4,
       0,     5,     0,     5,     0,     5,     1,     1,     1,     2,
       3,     2,     2,     0,     5,     3,     0,     5,     1,     0,
       1,     3,     5,     4,     1,     1,     1,     3,     1,     3,
       4,     4,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     3,     3,     1,     1,     1,     1,     1,
       1,     4,     4,     7,     7,     7,     7,     1,     2,     1,
       1,     1,     1,     1,     1,     3,     2,     3,     3,     4,
       5,     1,     2,     1,     2,     1,     0,     3,     1,     1,
       1,     0,     0,     4,     0,     3,     1,     2,     1,     2,
       1,     2,     1,     1,     3,     2,     1,     2,     1,     2,
       2,     3,     3,     2,     3,     1,     1,     1,     1,     1,
       2,     3,     2,     3,     3,     3,     2,     2,     3,     4,
       3,     3,     4,     3,     4,     3,     4,     2,     3,     2,
       3,     2,     3,     1,     2,     2,     2,     3,     2,     2,
       3,     2,     2,     3,     2,     2,     3,     2,     1,     2,
       1,     5,     2,     2,     1,     1,     1,     1,     1,     3,
       1,     3,     1,     2,     2,     0,     2,     2,     2,     1,
       1,     1,     2,     2,     4,     4,     4,     4,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to xreallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to xreallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 4: /* type_exp: type  */
#line 282 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode(pstate, OP_TYPE);
			  write_exp_elt_type(pstate, (yyvsp[0].tval));
			  write_exp_elt_opcode(pstate, OP_TYPE);}
#line 2102 "c-exp.c.tmp"
    break;

  case 5: /* type_exp: TYPEOF '(' exp ')'  */
#line 286 "../../../gdb/gdb/c-exp.y"
                        {
			  write_exp_elt_opcode (pstate, OP_TYPEOF);
			}
#line 2110 "c-exp.c.tmp"
    break;

  case 6: /* type_exp: TYPEOF '(' type ')'  */
#line 290 "../../../gdb/gdb/c-exp.y"
                        {
			  write_exp_elt_opcode (pstate, OP_TYPE);
			  write_exp_elt_type (pstate, (yyvsp[-1].tval));
			  write_exp_elt_opcode (pstate, OP_TYPE);
			}
#line 2120 "c-exp.c.tmp"
    break;

  case 7: /* type_exp: DECLTYPE '(' exp ')'  */
#line 296 "../../../gdb/gdb/c-exp.y"
                        {
			  write_exp_elt_opcode (pstate, OP_DECLTYPE);
			}
#line 2128 "c-exp.c.tmp"
    break;

  case 9: /* exp1: exp1 ',' exp  */
#line 304 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_COMMA); }
#line 2134 "c-exp.c.tmp"
    break;

  case 10: /* exp: '*' exp  */
#line 309 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_IND); }
#line 2140 "c-exp.c.tmp"
    break;

  case 11: /* exp: '&' exp  */
#line 313 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_ADDR); }
#line 2146 "c-exp.c.tmp"
    break;

  case 12: /* exp: '-' exp  */
#line 317 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_NEG); }
#line 2152 "c-exp.c.tmp"
    break;

  case 13: /* exp: '+' exp  */
#line 321 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_PLUS); }
#line 2158 "c-exp.c.tmp"
    break;

  case 14: /* exp: '!' exp  */
#line 325 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_LOGICAL_NOT); }
#line 2164 "c-exp.c.tmp"
    break;

  case 15: /* exp: '~' exp  */
#line 329 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_COMPLEMENT); }
#line 2170 "c-exp.c.tmp"
    break;

  case 16: /* exp: INCREMENT exp  */
#line 333 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_PREINCREMENT); }
#line 2176 "c-exp.c.tmp"
    break;

  case 17: /* exp: DECREMENT exp  */
#line 337 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_PREDECREMENT); }
#line 2182 "c-exp.c.tmp"
    break;

  case 18: /* exp: exp INCREMENT  */
#line 341 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_POSTINCREMENT); }
#line 2188 "c-exp.c.tmp"
    break;

  case 19: /* exp: exp DECREMENT  */
#line 345 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_POSTDECREMENT); }
#line 2194 "c-exp.c.tmp"
    break;

  case 20: /* exp: TYPEID '(' exp ')'  */
#line 349 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_TYPEID); }
#line 2200 "c-exp.c.tmp"
    break;

  case 21: /* exp: TYPEID '(' type_exp ')'  */
#line 353 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_TYPEID); }
#line 2206 "c-exp.c.tmp"
    break;

  case 22: /* exp: SIZEOF exp  */
#line 357 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_SIZEOF); }
#line 2212 "c-exp.c.tmp"
    break;

  case 23: /* exp: ALIGNOF '(' type_exp ')'  */
#line 361 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_ALIGNOF); }
#line 2218 "c-exp.c.tmp"
    break;

  case 24: /* exp: exp ARROW field_name  */
#line 365 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, STRUCTOP_PTR);
			  write_exp_string (pstate, (yyvsp[0].sval));
			  write_exp_elt_opcode (pstate, STRUCTOP_PTR); }
#line 2226 "c-exp.c.tmp"
    break;

  case 25: /* exp: exp ARROW field_name COMPLETE  */
#line 371 "../../../gdb/gdb/c-exp.y"
                        { pstate->mark_struct_expression ();
			  write_exp_elt_opcode (pstate, STRUCTOP_PTR);
			  write_exp_string (pstate, (yyvsp[-1].sval));
			  write_exp_elt_opcode (pstate, STRUCTOP_PTR); }
#line 2235 "c-exp.c.tmp"
    break;

  case 26: /* exp: exp ARROW COMPLETE  */
#line 378 "../../../gdb/gdb/c-exp.y"
                        { struct stoken s;
			  pstate->mark_struct_expression ();
			  write_exp_elt_opcode (pstate, STRUCTOP_PTR);
			  s.ptr = "";
			  s.length = 0;
			  write_exp_string (pstate, s);
			  write_exp_elt_opcode (pstate, STRUCTOP_PTR); }
#line 2247 "c-exp.c.tmp"
    break;

  case 27: /* exp: exp ARROW '~' name  */
#line 388 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, STRUCTOP_PTR);
			  write_destructor_name (pstate, (yyvsp[0].sval));
			  write_exp_elt_opcode (pstate, STRUCTOP_PTR); }
#line 2255 "c-exp.c.tmp"
    break;

  case 28: /* exp: exp ARROW '~' name COMPLETE  */
#line 394 "../../../gdb/gdb/c-exp.y"
                        { pstate->mark_struct_expression ();
			  write_exp_elt_opcode (pstate, STRUCTOP_PTR);
			  write_destructor_name (pstate, (yyvsp[-1].sval));
			  write_exp_elt_opcode (pstate, STRUCTOP_PTR); }
#line 2264 "c-exp.c.tmp"
    break;

  case 29: /* exp: exp ARROW qualified_name  */
#line 401 "../../../gdb/gdb/c-exp.y"
                        { /* exp->type::name becomes exp->*(&type::name) */
			  /* Note: this doesn't work if name is a
			     static member!  FIXME */
			  write_exp_elt_opcode (pstate, UNOP_ADDR);
			  write_exp_elt_opcode (pstate, STRUCTOP_MPTR); }
#line 2274 "c-exp.c.tmp"
    break;

  case 30: /* exp: exp ARROW_STAR exp  */
#line 409 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, STRUCTOP_MPTR); }
#line 2280 "c-exp.c.tmp"
    break;

  case 31: /* exp: exp '.' field_name  */
#line 413 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, STRUCTOP_STRUCT);
			  write_exp_string (pstate, (yyvsp[0].sval));
			  write_exp_elt_opcode (pstate, STRUCTOP_STRUCT); }
#line 2288 "c-exp.c.tmp"
    break;

  case 32: /* exp: exp '.' field_name COMPLETE  */
#line 419 "../../../gdb/gdb/c-exp.y"
                        { pstate->mark_struct_expression ();
			  write_exp_elt_opcode (pstate, STRUCTOP_STRUCT);
			  write_exp_string (pstate, (yyvsp[-1].sval));
			  write_exp_elt_opcode (pstate, STRUCTOP_STRUCT); }
#line 2297 "c-exp.c.tmp"
    break;

  case 33: /* exp: exp '.' COMPLETE  */
#line 426 "../../../gdb/gdb/c-exp.y"
                        { struct stoken s;
			  pstate->mark_struct_expression ();
			  write_exp_elt_opcode (pstate, STRUCTOP_STRUCT);
			  s.ptr = "";
			  s.length = 0;
			  write_exp_string (pstate, s);
			  write_exp_elt_opcode (pstate, STRUCTOP_STRUCT); }
#line 2309 "c-exp.c.tmp"
    break;

  case 34: /* exp: exp '.' '~' name  */
#line 436 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, STRUCTOP_STRUCT);
			  write_destructor_name (pstate, (yyvsp[0].sval));
			  write_exp_elt_opcode (pstate, STRUCTOP_STRUCT); }
#line 2317 "c-exp.c.tmp"
    break;

  case 35: /* exp: exp '.' '~' name COMPLETE  */
#line 442 "../../../gdb/gdb/c-exp.y"
                        { pstate->mark_struct_expression ();
			  write_exp_elt_opcode (pstate, STRUCTOP_STRUCT);
			  write_destructor_name (pstate, (yyvsp[-1].sval));
			  write_exp_elt_opcode (pstate, STRUCTOP_STRUCT); }
#line 2326 "c-exp.c.tmp"
    break;

  case 36: /* exp: exp '.' qualified_name  */
#line 449 "../../../gdb/gdb/c-exp.y"
                        { /* exp.type::name becomes exp.*(&type::name) */
			  /* Note: this doesn't work if name is a
			     static member!  FIXME */
			  write_exp_elt_opcode (pstate, UNOP_ADDR);
			  write_exp_elt_opcode (pstate, STRUCTOP_MEMBER); }
#line 2336 "c-exp.c.tmp"
    break;

  case 37: /* exp: exp DOT_STAR exp  */
#line 457 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, STRUCTOP_MEMBER); }
#line 2342 "c-exp.c.tmp"
    break;

  case 38: /* exp: exp '[' exp1 ']'  */
#line 461 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_SUBSCRIPT); }
#line 2348 "c-exp.c.tmp"
    break;

  case 39: /* exp: exp OBJC_LBRAC exp1 ']'  */
#line 465 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_SUBSCRIPT); }
#line 2354 "c-exp.c.tmp"
    break;

  case 40: /* $@1: %empty  */
#line 474 "../../../gdb/gdb/c-exp.y"
                        {
			  CORE_ADDR theclass;

			  std::string copy = copy_name ((yyvsp[0].tsym).stoken);
			  theclass = lookup_objc_class (pstate->gdbarch (),
							copy.c_str ());
			  if (theclass == 0)
			    error (_("%s is not an ObjC Class"),
				   copy.c_str ());
			  write_exp_elt_opcode (pstate, OP_LONG);
			  write_exp_elt_type (pstate,
					      parse_type (pstate)->builtin_int);
			  write_exp_elt_longcst (pstate, (LONGEST) theclass);
			  write_exp_elt_opcode (pstate, OP_LONG);
			  start_msglist();
			}
#line 2375 "c-exp.c.tmp"
    break;

  case 41: /* exp: OBJC_LBRAC TYPENAME $@1 msglist ']'  */
#line 491 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_OBJC_MSGCALL);
			  end_msglist (pstate);
			  write_exp_elt_opcode (pstate, OP_OBJC_MSGCALL);
			}
#line 2384 "c-exp.c.tmp"
    break;

  case 42: /* $@2: %empty  */
#line 498 "../../../gdb/gdb/c-exp.y"
                        {
			  write_exp_elt_opcode (pstate, OP_LONG);
			  write_exp_elt_type (pstate,
					    parse_type (pstate)->builtin_int);
			  write_exp_elt_longcst (pstate, (LONGEST) (yyvsp[0].theclass).theclass);
			  write_exp_elt_opcode (pstate, OP_LONG);
			  start_msglist();
			}
#line 2397 "c-exp.c.tmp"
    break;

  case 43: /* exp: OBJC_LBRAC CLASSNAME $@2 msglist ']'  */
#line 507 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_OBJC_MSGCALL);
			  end_msglist (pstate);
			  write_exp_elt_opcode (pstate, OP_OBJC_MSGCALL);
			}
#line 2406 "c-exp.c.tmp"
    break;

  case 44: /* $@3: %empty  */
#line 514 "../../../gdb/gdb/c-exp.y"
                        { start_msglist(); }
#line 2412 "c-exp.c.tmp"
    break;

  case 45: /* exp: OBJC_LBRAC exp $@3 msglist ']'  */
#line 516 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_OBJC_MSGCALL);
			  end_msglist (pstate);
			  write_exp_elt_opcode (pstate, OP_OBJC_MSGCALL);
			}
#line 2421 "c-exp.c.tmp"
    break;

  case 46: /* msglist: name  */
#line 523 "../../../gdb/gdb/c-exp.y"
                        { add_msglist(&(yyvsp[0].sval), 0); }
#line 2427 "c-exp.c.tmp"
    break;

  case 50: /* msgarg: name ':' exp  */
#line 532 "../../../gdb/gdb/c-exp.y"
                        { add_msglist(&(yyvsp[-2].sval), 1); }
#line 2433 "c-exp.c.tmp"
    break;

  case 51: /* msgarg: ':' exp  */
#line 534 "../../../gdb/gdb/c-exp.y"
                        { add_msglist(0, 1);   }
#line 2439 "c-exp.c.tmp"
    break;

  case 52: /* msgarg: ',' exp  */
#line 536 "../../../gdb/gdb/c-exp.y"
                        { add_msglist(0, 0);   }
#line 2445 "c-exp.c.tmp"
    break;

  case 53: /* $@4: %empty  */
#line 542 "../../../gdb/gdb/c-exp.y"
                        { pstate->start_arglist (); }
#line 2451 "c-exp.c.tmp"
    break;

  case 54: /* exp: exp '(' $@4 arglist ')'  */
#line 544 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_FUNCALL);
			  write_exp_elt_longcst (pstate,
						 pstate->end_arglist ());
			  write_exp_elt_opcode (pstate, OP_FUNCALL); }
#line 2460 "c-exp.c.tmp"
    break;

  case 55: /* exp: exp '(' ')'  */
#line 554 "../../../gdb/gdb/c-exp.y"
                        { pstate->start_arglist ();
			  write_exp_elt_opcode (pstate, OP_FUNCALL);
			  write_exp_elt_longcst (pstate,
						 pstate->end_arglist ());
			  write_exp_elt_opcode (pstate, OP_FUNCALL); }
#line 2470 "c-exp.c.tmp"
    break;

  case 56: /* $@5: %empty  */
#line 563 "../../../gdb/gdb/c-exp.y"
                        {
			  /* This could potentially be a an argument defined
			     lookup function (Koenig).  */
			  write_exp_elt_opcode (pstate, OP_ADL_FUNC);
			  write_exp_elt_block
			    (pstate, pstate->expression_context_block);
			  write_exp_elt_sym (pstate,
					     NULL); /* Placeholder.  */
			  write_exp_string (pstate, (yyvsp[-1].ssym).stoken);
			  write_exp_elt_opcode (pstate, OP_ADL_FUNC);

			/* This is to save the value of arglist_len
			   being accumulated by an outer function call.  */

			  pstate->start_arglist ();
			}
#line 2491 "c-exp.c.tmp"
    break;

  case 57: /* exp: UNKNOWN_CPP_NAME '(' $@5 arglist ')'  */
#line 580 "../../../gdb/gdb/c-exp.y"
                        {
			  write_exp_elt_opcode (pstate, OP_FUNCALL);
			  write_exp_elt_longcst (pstate,
						 pstate->end_arglist ());
			  write_exp_elt_opcode (pstate, OP_FUNCALL);
			}
#line 2502 "c-exp.c.tmp"
    break;

  case 58: /* lcurly: '{'  */
#line 589 "../../../gdb/gdb/c-exp.y"
                        { pstate->start_arglist (); }
#line 2508 "c-exp.c.tmp"
    break;

  case 60: /* arglist: exp  */
#line 596 "../../../gdb/gdb/c-exp.y"
                        { pstate->arglist_len = 1; }
#line 2514 "c-exp.c.tmp"
    break;

  case 61: /* arglist: arglist ',' exp  */
#line 600 "../../../gdb/gdb/c-exp.y"
                        { pstate->arglist_len++; }
#line 2520 "c-exp.c.tmp"
    break;

  case 62: /* function_method: exp '(' parameter_typelist ')' const_or_volatile  */
#line 604 "../../../gdb/gdb/c-exp.y"
                        {
			  std::vector<struct type *> *type_list = (yyvsp[-2].tvec);
			  LONGEST len = type_list->size ();

			  write_exp_elt_opcode (pstate, TYPE_INSTANCE);
			  /* Save the const/volatile qualifiers as
			     recorded by the const_or_volatile
			     production's actions.  */
			  write_exp_elt_longcst
			    (pstate,
			     (cpstate->type_stack
			      .follow_type_instance_flags ()));
			  write_exp_elt_longcst (pstate, len);
			  for (type *type_elt : *type_list)
			    write_exp_elt_type (pstate, type_elt);
			  write_exp_elt_longcst(pstate, len);
			  write_exp_elt_opcode (pstate, TYPE_INSTANCE);
			}
#line 2543 "c-exp.c.tmp"
    break;

  case 63: /* function_method_void: exp '(' ')' const_or_volatile  */
#line 625 "../../../gdb/gdb/c-exp.y"
                       { write_exp_elt_opcode (pstate, TYPE_INSTANCE);
			 /* See above.  */
			 write_exp_elt_longcst
			   (pstate,
			    cpstate->type_stack.follow_type_instance_flags ());
			 write_exp_elt_longcst (pstate, 0);
			 write_exp_elt_longcst (pstate, 0);
			 write_exp_elt_opcode (pstate, TYPE_INSTANCE);
		       }
#line 2557 "c-exp.c.tmp"
    break;

  case 67: /* exp: function_method_void_or_typelist COLONCOLON name  */
#line 648 "../../../gdb/gdb/c-exp.y"
                        {
			  write_exp_elt_opcode (pstate, OP_FUNC_STATIC_VAR);
			  write_exp_string (pstate, (yyvsp[0].sval));
			  write_exp_elt_opcode (pstate, OP_FUNC_STATIC_VAR);
			}
#line 2567 "c-exp.c.tmp"
    break;

  case 68: /* rcurly: '}'  */
#line 656 "../../../gdb/gdb/c-exp.y"
                        { (yyval.lval) = pstate->end_arglist () - 1; }
#line 2573 "c-exp.c.tmp"
    break;

  case 69: /* exp: lcurly arglist rcurly  */
#line 659 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_ARRAY);
			  write_exp_elt_longcst (pstate, (LONGEST) 0);
			  write_exp_elt_longcst (pstate, (LONGEST) (yyvsp[0].lval));
			  write_exp_elt_opcode (pstate, OP_ARRAY); }
#line 2582 "c-exp.c.tmp"
    break;

  case 70: /* exp: lcurly type_exp rcurly exp  */
#line 666 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_MEMVAL_TYPE); }
#line 2588 "c-exp.c.tmp"
    break;

  case 71: /* exp: '(' type_exp ')' exp  */
#line 670 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_CAST_TYPE); }
#line 2594 "c-exp.c.tmp"
    break;

  case 72: /* exp: '(' exp1 ')'  */
#line 674 "../../../gdb/gdb/c-exp.y"
                        { }
#line 2600 "c-exp.c.tmp"
    break;

  case 73: /* exp: exp '@' exp  */
#line 680 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_REPEAT); }
#line 2606 "c-exp.c.tmp"
    break;

  case 74: /* exp: exp '*' exp  */
#line 684 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_MUL); }
#line 2612 "c-exp.c.tmp"
    break;

  case 75: /* exp: exp '/' exp  */
#line 688 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_DIV); }
#line 2618 "c-exp.c.tmp"
    break;

  case 76: /* exp: exp '%' exp  */
#line 692 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_REM); }
#line 2624 "c-exp.c.tmp"
    break;

  case 77: /* exp: exp '+' exp  */
#line 696 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_ADD); }
#line 2630 "c-exp.c.tmp"
    break;

  case 78: /* exp: exp '-' exp  */
#line 700 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_SUB); }
#line 2636 "c-exp.c.tmp"
    break;

  case 79: /* exp: exp LSH exp  */
#line 704 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_LSH); }
#line 2642 "c-exp.c.tmp"
    break;

  case 80: /* exp: exp RSH exp  */
#line 708 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_RSH); }
#line 2648 "c-exp.c.tmp"
    break;

  case 81: /* exp: exp EQUAL exp  */
#line 712 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_EQUAL); }
#line 2654 "c-exp.c.tmp"
    break;

  case 82: /* exp: exp NOTEQUAL exp  */
#line 716 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_NOTEQUAL); }
#line 2660 "c-exp.c.tmp"
    break;

  case 83: /* exp: exp LEQ exp  */
#line 720 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_LEQ); }
#line 2666 "c-exp.c.tmp"
    break;

  case 84: /* exp: exp GEQ exp  */
#line 724 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_GEQ); }
#line 2672 "c-exp.c.tmp"
    break;

  case 85: /* exp: exp '<' exp  */
#line 728 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_LESS); }
#line 2678 "c-exp.c.tmp"
    break;

  case 86: /* exp: exp '>' exp  */
#line 732 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_GTR); }
#line 2684 "c-exp.c.tmp"
    break;

  case 87: /* exp: exp '&' exp  */
#line 736 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_BITWISE_AND); }
#line 2690 "c-exp.c.tmp"
    break;

  case 88: /* exp: exp '^' exp  */
#line 740 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_BITWISE_XOR); }
#line 2696 "c-exp.c.tmp"
    break;

  case 89: /* exp: exp '|' exp  */
#line 744 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_BITWISE_IOR); }
#line 2702 "c-exp.c.tmp"
    break;

  case 90: /* exp: exp ANDAND exp  */
#line 748 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_LOGICAL_AND); }
#line 2708 "c-exp.c.tmp"
    break;

  case 91: /* exp: exp OROR exp  */
#line 752 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_LOGICAL_OR); }
#line 2714 "c-exp.c.tmp"
    break;

  case 92: /* exp: exp '?' exp ':' exp  */
#line 756 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, TERNOP_COND); }
#line 2720 "c-exp.c.tmp"
    break;

  case 93: /* exp: exp '=' exp  */
#line 760 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_ASSIGN); }
#line 2726 "c-exp.c.tmp"
    break;

  case 94: /* exp: exp ASSIGN_MODIFY exp  */
#line 764 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, BINOP_ASSIGN_MODIFY);
			  write_exp_elt_opcode (pstate, (yyvsp[-1].opcode));
			  write_exp_elt_opcode (pstate,
						BINOP_ASSIGN_MODIFY); }
#line 2735 "c-exp.c.tmp"
    break;

  case 95: /* exp: INT  */
#line 771 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_LONG);
			  write_exp_elt_type (pstate, (yyvsp[0].typed_val_int).type);
			  write_exp_elt_longcst (pstate, (LONGEST) ((yyvsp[0].typed_val_int).val));
			  write_exp_elt_opcode (pstate, OP_LONG); }
#line 2744 "c-exp.c.tmp"
    break;

  case 96: /* exp: CHAR  */
#line 778 "../../../gdb/gdb/c-exp.y"
                        {
			  struct stoken_vector vec;
			  vec.len = 1;
			  vec.tokens = &(yyvsp[0].tsval);
			  write_exp_string_vector (pstate, (yyvsp[0].tsval).type, &vec);
			}
#line 2755 "c-exp.c.tmp"
    break;

  case 97: /* exp: NAME_OR_INT  */
#line 787 "../../../gdb/gdb/c-exp.y"
                        { YYSTYPE val;
			  parse_number (pstate, (yyvsp[0].ssym).stoken.ptr,
					(yyvsp[0].ssym).stoken.length, 0, &val);
			  write_exp_elt_opcode (pstate, OP_LONG);
			  write_exp_elt_type (pstate, val.typed_val_int.type);
			  write_exp_elt_longcst (pstate,
					    (LONGEST) val.typed_val_int.val);
			  write_exp_elt_opcode (pstate, OP_LONG);
			}
#line 2769 "c-exp.c.tmp"
    break;

  case 98: /* exp: FLOAT  */
#line 800 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_FLOAT);
			  write_exp_elt_type (pstate, (yyvsp[0].typed_val_float).type);
			  write_exp_elt_floatcst (pstate, (yyvsp[0].typed_val_float).val);
			  write_exp_elt_opcode (pstate, OP_FLOAT); }
#line 2778 "c-exp.c.tmp"
    break;

  case 100: /* exp: DOLLAR_VARIABLE  */
#line 810 "../../../gdb/gdb/c-exp.y"
                        {
			  write_dollar_variable (pstate, (yyvsp[0].sval));
			}
#line 2786 "c-exp.c.tmp"
    break;

  case 101: /* exp: SELECTOR '(' name ')'  */
#line 816 "../../../gdb/gdb/c-exp.y"
                        {
			  write_exp_elt_opcode (pstate, OP_OBJC_SELECTOR);
			  write_exp_string (pstate, (yyvsp[-1].sval));
			  write_exp_elt_opcode (pstate, OP_OBJC_SELECTOR); }
#line 2795 "c-exp.c.tmp"
    break;

  case 102: /* exp: SIZEOF '(' type ')'  */
#line 823 "../../../gdb/gdb/c-exp.y"
                        { struct type *type = (yyvsp[-1].tval);
			  write_exp_elt_opcode (pstate, OP_LONG);
			  write_exp_elt_type (pstate, lookup_signed_typename
					      (pstate->language (),
					       "int"));
			  type = check_typedef (type);

			    /* $5.3.3/2 of the C++ Standard (n3290 draft)
			       says of sizeof:  "When applied to a reference
			       or a reference type, the result is the size of
			       the referenced type."  */
			  if (TYPE_IS_REFERENCE (type))
			    type = check_typedef (TYPE_TARGET_TYPE (type));
			  write_exp_elt_longcst (pstate,
						 (LONGEST) TYPE_LENGTH (type));
			  write_exp_elt_opcode (pstate, OP_LONG); }
#line 2816 "c-exp.c.tmp"
    break;

  case 103: /* exp: REINTERPRET_CAST '<' type_exp '>' '(' exp ')'  */
#line 842 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate,
						UNOP_REINTERPRET_CAST); }
#line 2823 "c-exp.c.tmp"
    break;

  case 104: /* exp: STATIC_CAST '<' type_exp '>' '(' exp ')'  */
#line 847 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_CAST_TYPE); }
#line 2829 "c-exp.c.tmp"
    break;

  case 105: /* exp: DYNAMIC_CAST '<' type_exp '>' '(' exp ')'  */
#line 851 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, UNOP_DYNAMIC_CAST); }
#line 2835 "c-exp.c.tmp"
    break;

  case 106: /* exp: CONST_CAST '<' type_exp '>' '(' exp ')'  */
#line 855 "../../../gdb/gdb/c-exp.y"
                        { /* We could do more error checking here, but
			     it doesn't seem worthwhile.  */
			  write_exp_elt_opcode (pstate, UNOP_CAST_TYPE); }
#line 2843 "c-exp.c.tmp"
    break;

  case 107: /* string_exp: STRING  */
#line 862 "../../../gdb/gdb/c-exp.y"
                        {
			  /* We copy the string here, and not in the
			     lexer, to guarantee that we do not leak a
			     string.  Note that we follow the
			     NUL-termination convention of the
			     lexer.  */
			  struct typed_stoken *vec = XNEW (struct typed_stoken);
			  (yyval.svec).len = 1;
			  (yyval.svec).tokens = vec;

			  vec->type = (yyvsp[0].tsval).type;
			  vec->length = (yyvsp[0].tsval).length;
			  vec->ptr = (char *) xmalloc ((yyvsp[0].tsval).length + 1);
			  memcpy (vec->ptr, (yyvsp[0].tsval).ptr, (yyvsp[0].tsval).length + 1);
			}
#line 2863 "c-exp.c.tmp"
    break;

  case 108: /* string_exp: string_exp STRING  */
#line 879 "../../../gdb/gdb/c-exp.y"
                        {
			  /* Note that we NUL-terminate here, but just
			     for convenience.  */
			  char *p;
			  ++(yyval.svec).len;
			  (yyval.svec).tokens = XRESIZEVEC (struct typed_stoken,
						  (yyval.svec).tokens, (yyval.svec).len);

			  p = (char *) xmalloc ((yyvsp[0].tsval).length + 1);
			  memcpy (p, (yyvsp[0].tsval).ptr, (yyvsp[0].tsval).length + 1);

			  (yyval.svec).tokens[(yyval.svec).len - 1].type = (yyvsp[0].tsval).type;
			  (yyval.svec).tokens[(yyval.svec).len - 1].length = (yyvsp[0].tsval).length;
			  (yyval.svec).tokens[(yyval.svec).len - 1].ptr = p;
			}
#line 2883 "c-exp.c.tmp"
    break;

  case 109: /* exp: string_exp  */
#line 897 "../../../gdb/gdb/c-exp.y"
                        {
			  int i;
			  c_string_type type = C_STRING;

			  for (i = 0; i < (yyvsp[0].svec).len; ++i)
			    {
			      switch ((yyvsp[0].svec).tokens[i].type)
				{
				case C_STRING:
				  break;
				case C_WIDE_STRING:
				case C_STRING_16:
				case C_STRING_32:
				  if (type != C_STRING
				      && type != (yyvsp[0].svec).tokens[i].type)
				    error (_("Undefined string concatenation."));
				  type = (enum c_string_type_values) (yyvsp[0].svec).tokens[i].type;
				  break;
				default:
				  /* internal error */
				  internal_error (__FILE__, __LINE__,
						  "unrecognized type in string concatenation");
				}
			    }

			  write_exp_string_vector (pstate, type, &(yyvsp[0].svec));
			  for (i = 0; i < (yyvsp[0].svec).len; ++i)
			    xfree ((yyvsp[0].svec).tokens[i].ptr);
			  xfree ((yyvsp[0].svec).tokens);
			}
#line 2918 "c-exp.c.tmp"
    break;

  case 110: /* exp: NSSTRING  */
#line 932 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_OBJC_NSSTRING);
			  write_exp_string (pstate, (yyvsp[0].sval));
			  write_exp_elt_opcode (pstate, OP_OBJC_NSSTRING); }
#line 2926 "c-exp.c.tmp"
    break;

  case 111: /* exp: TRUEKEYWORD  */
#line 939 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_LONG);
                          write_exp_elt_type (pstate,
					  parse_type (pstate)->builtin_bool);
                          write_exp_elt_longcst (pstate, (LONGEST) 1);
                          write_exp_elt_opcode (pstate, OP_LONG); }
#line 2936 "c-exp.c.tmp"
    break;

  case 112: /* exp: FALSEKEYWORD  */
#line 947 "../../../gdb/gdb/c-exp.y"
                        { write_exp_elt_opcode (pstate, OP_LONG);
                          write_exp_elt_type (pstate,
					  parse_type (pstate)->builtin_bool);
                          write_exp_elt_longcst (pstate, (LONGEST) 0);
                          write_exp_elt_opcode (pstate, OP_LONG); }
#line 2946 "c-exp.c.tmp"
    break;

  case 113: /* block: BLOCKNAME  */
#line 957 "../../../gdb/gdb/c-exp.y"
                        {
			  if ((yyvsp[0].ssym).sym.symbol)
			    (yyval.bval) = SYMBOL_BLOCK_VALUE ((yyvsp[0].ssym).sym.symbol);
			  else
			    error (_("No file or function \"%s\"."),
				   copy_name ((yyvsp[0].ssym).stoken).c_str ());
			}
#line 2958 "c-exp.c.tmp"
    break;

  case 114: /* block: FILENAME  */
#line 965 "../../../gdb/gdb/c-exp.y"
                        {
			  (yyval.bval) = (yyvsp[0].bval);
			}
#line 2966 "c-exp.c.tmp"
    break;

  case 115: /* block: block COLONCOLON name  */
#line 971 "../../../gdb/gdb/c-exp.y"
                        {
			  std::string copy = copy_name ((yyvsp[0].sval));
			  struct symbol *tem
			    = lookup_symbol (copy.c_str (), (yyvsp[-2].bval),
					     VAR_DOMAIN, NULL).symbol;

			  if (!tem || SYMBOL_CLASS (tem) != LOC_BLOCK)
			    error (_("No function \"%s\" in specified context."),
				   copy.c_str ());
			  (yyval.bval) = SYMBOL_BLOCK_VALUE (tem); }
#line 2981 "c-exp.c.tmp"
    break;

  case 116: /* variable: name_not_typename ENTRY  */
#line 984 "../../../gdb/gdb/c-exp.y"
                        { struct symbol *sym = (yyvsp[-1].ssym).sym.symbol;

			  if (sym == NULL || !SYMBOL_IS_ARGUMENT (sym)
			      || !symbol_read_needs_frame (sym))
			    error (_("@entry can be used only for function "
				     "parameters, not for \"%s\""),
				   copy_name ((yyvsp[-1].ssym).stoken).c_str ());

			  write_exp_elt_opcode (pstate, OP_VAR_ENTRY_VALUE);
			  write_exp_elt_sym (pstate, sym);
			  write_exp_elt_opcode (pstate, OP_VAR_ENTRY_VALUE);
			}
#line 2998 "c-exp.c.tmp"
    break;

  case 117: /* variable: block COLONCOLON name  */
#line 999 "../../../gdb/gdb/c-exp.y"
                        {
			  std::string copy = copy_name ((yyvsp[0].sval));
			  struct block_symbol sym
			    = lookup_symbol (copy.c_str (), (yyvsp[-2].bval),
					     VAR_DOMAIN, NULL);

			  if (sym.symbol == 0)
			    error (_("No symbol \"%s\" in specified context."),
				   copy.c_str ());
			  if (symbol_read_needs_frame (sym.symbol))
			    pstate->block_tracker->update (sym);

			  write_exp_elt_opcode (pstate, OP_VAR_VALUE);
			  write_exp_elt_block (pstate, sym.block);
			  write_exp_elt_sym (pstate, sym.symbol);
			  write_exp_elt_opcode (pstate, OP_VAR_VALUE); }
#line 3019 "c-exp.c.tmp"
    break;

  case 118: /* qualified_name: TYPENAME COLONCOLON name  */
#line 1018 "../../../gdb/gdb/c-exp.y"
                        {
			  struct type *type = (yyvsp[-2].tsym).type;
			  type = check_typedef (type);
			  if (!type_aggregate_p (type))
			    error (_("`%s' is not defined as an aggregate type."),
				   TYPE_SAFE_NAME (type));

			  write_exp_elt_opcode (pstate, OP_SCOPE);
			  write_exp_elt_type (pstate, type);
			  write_exp_string (pstate, (yyvsp[0].sval));
			  write_exp_elt_opcode (pstate, OP_SCOPE);
			}
#line 3036 "c-exp.c.tmp"
    break;

  case 119: /* qualified_name: TYPENAME COLONCOLON '~' name  */
#line 1031 "../../../gdb/gdb/c-exp.y"
                        {
			  struct type *type = (yyvsp[-3].tsym).type;
			  struct stoken tmp_token;
			  char *buf;

			  type = check_typedef (type);
			  if (!type_aggregate_p (type))
			    error (_("`%s' is not defined as an aggregate type."),
				   TYPE_SAFE_NAME (type));
			  buf = (char *) alloca ((yyvsp[0].sval).length + 2);
			  tmp_token.ptr = buf;
			  tmp_token.length = (yyvsp[0].sval).length + 1;
			  buf[0] = '~';
			  memcpy (buf+1, (yyvsp[0].sval).ptr, (yyvsp[0].sval).length);
			  buf[tmp_token.length] = 0;

			  /* Check for valid destructor name.  */
			  destructor_name_p (tmp_token.ptr, (yyvsp[-3].tsym).type);
			  write_exp_elt_opcode (pstate, OP_SCOPE);
			  write_exp_elt_type (pstate, type);
			  write_exp_string (pstate, tmp_token);
			  write_exp_elt_opcode (pstate, OP_SCOPE);
			}
#line 3064 "c-exp.c.tmp"
    break;

  case 120: /* qualified_name: TYPENAME COLONCOLON name COLONCOLON name  */
#line 1055 "../../../gdb/gdb/c-exp.y"
                        {
			  std::string copy = copy_name ((yyvsp[-2].sval));
			  error (_("No type \"%s\" within class "
				   "or namespace \"%s\"."),
				 copy.c_str (), TYPE_SAFE_NAME ((yyvsp[-4].tsym).type));
			}
#line 3075 "c-exp.c.tmp"
    break;

  case 122: /* variable: COLONCOLON name_not_typename  */
#line 1065 "../../../gdb/gdb/c-exp.y"
                        {
			  std::string name = copy_name ((yyvsp[0].ssym).stoken);
			  struct symbol *sym;
			  struct bound_minimal_symbol msymbol;

			  sym
			    = lookup_symbol (name.c_str (),
					     (const struct block *) NULL,
					     VAR_DOMAIN, NULL).symbol;
			  if (sym)
			    {
			      write_exp_elt_opcode (pstate, OP_VAR_VALUE);
			      write_exp_elt_block (pstate, NULL);
			      write_exp_elt_sym (pstate, sym);
			      write_exp_elt_opcode (pstate, OP_VAR_VALUE);
			      break;
			    }

			  msymbol = lookup_bound_minimal_symbol (name.c_str ());
			  if (msymbol.minsym != NULL)
			    write_exp_msymbol (pstate, msymbol);
			  else if (!have_full_symbols () && !have_partial_symbols ())
			    error (_("No symbol table is loaded.  Use the \"file\" command."));
			  else
			    error (_("No symbol \"%s\" in current context."),
				   name.c_str ());
			}
#line 3107 "c-exp.c.tmp"
    break;

  case 123: /* variable: name_not_typename  */
#line 1095 "../../../gdb/gdb/c-exp.y"
                        { struct block_symbol sym = (yyvsp[0].ssym).sym;

			  if (sym.symbol)
			    {
			      if (symbol_read_needs_frame (sym.symbol))
				pstate->block_tracker->update (sym);

			      /* If we found a function, see if it's
				 an ifunc resolver that has the same
				 address as the ifunc symbol itself.
				 If so, prefer the ifunc symbol.  */

			      bound_minimal_symbol resolver
				= find_gnu_ifunc (sym.symbol);
			      if (resolver.minsym != NULL)
				write_exp_msymbol (pstate, resolver);
			      else
				{
				  write_exp_elt_opcode (pstate, OP_VAR_VALUE);
				  write_exp_elt_block (pstate, sym.block);
				  write_exp_elt_sym (pstate, sym.symbol);
				  write_exp_elt_opcode (pstate, OP_VAR_VALUE);
				}
			    }
			  else if ((yyvsp[0].ssym).is_a_field_of_this)
			    {
			      /* C++: it hangs off of `this'.  Must
			         not inadvertently convert from a method call
				 to data ref.  */
			      pstate->block_tracker->update (sym);
			      write_exp_elt_opcode (pstate, OP_THIS);
			      write_exp_elt_opcode (pstate, OP_THIS);
			      write_exp_elt_opcode (pstate, STRUCTOP_PTR);
			      write_exp_string (pstate, (yyvsp[0].ssym).stoken);
			      write_exp_elt_opcode (pstate, STRUCTOP_PTR);
			    }
			  else
			    {
			      std::string arg = copy_name ((yyvsp[0].ssym).stoken);

			      bound_minimal_symbol msymbol
				= lookup_bound_minimal_symbol (arg.c_str ());
			      if (msymbol.minsym == NULL)
				{
				  if (!have_full_symbols () && !have_partial_symbols ())
				    error (_("No symbol table is loaded.  Use the \"file\" command."));
				  else
				    error (_("No symbol \"%s\" in current context."),
					   arg.c_str ());
				}

			      /* This minsym might be an alias for
				 another function.  See if we can find
				 the debug symbol for the target, and
				 if so, use it instead, since it has
				 return type / prototype info.  This
				 is important for example for "p
				 *__errno_location()".  */
			      symbol *alias_target
				= ((msymbol.minsym->type != mst_text_gnu_ifunc
				    && msymbol.minsym->type != mst_data_gnu_ifunc)
				   ? find_function_alias_target (msymbol)
				   : NULL);
			      if (alias_target != NULL)
				{
				  write_exp_elt_opcode (pstate, OP_VAR_VALUE);
				  write_exp_elt_block
				    (pstate, SYMBOL_BLOCK_VALUE (alias_target));
				  write_exp_elt_sym (pstate, alias_target);
				  write_exp_elt_opcode (pstate, OP_VAR_VALUE);
				}
			      else
				write_exp_msymbol (pstate, msymbol);
			    }
			}
#line 3187 "c-exp.c.tmp"
    break;

  case 124: /* space_identifier: '@' NAME  */
#line 1173 "../../../gdb/gdb/c-exp.y"
                {
		  cpstate->type_stack.insert (pstate,
					      copy_name ((yyvsp[0].ssym).stoken).c_str ());
		}
#line 3196 "c-exp.c.tmp"
    break;

  case 132: /* $@6: %empty  */
#line 1197 "../../../gdb/gdb/c-exp.y"
                        { cpstate->type_stack.insert (tp_pointer); }
#line 3202 "c-exp.c.tmp"
    break;

  case 134: /* $@7: %empty  */
#line 1200 "../../../gdb/gdb/c-exp.y"
                        { cpstate->type_stack.insert (tp_pointer); }
#line 3208 "c-exp.c.tmp"
    break;

  case 136: /* ptr_operator: '&'  */
#line 1203 "../../../gdb/gdb/c-exp.y"
                        { cpstate->type_stack.insert (tp_reference); }
#line 3214 "c-exp.c.tmp"
    break;

  case 137: /* ptr_operator: '&' ptr_operator  */
#line 1205 "../../../gdb/gdb/c-exp.y"
                        { cpstate->type_stack.insert (tp_reference); }
#line 3220 "c-exp.c.tmp"
    break;

  case 138: /* ptr_operator: ANDAND  */
#line 1207 "../../../gdb/gdb/c-exp.y"
                        { cpstate->type_stack.insert (tp_rvalue_reference); }
#line 3226 "c-exp.c.tmp"
    break;

  case 139: /* ptr_operator: ANDAND ptr_operator  */
#line 1209 "../../../gdb/gdb/c-exp.y"
                        { cpstate->type_stack.insert (tp_rvalue_reference); }
#line 3232 "c-exp.c.tmp"
    break;

  case 140: /* ptr_operator_ts: ptr_operator  */
#line 1213 "../../../gdb/gdb/c-exp.y"
                        {
			  (yyval.type_stack) = cpstate->type_stack.create ();
			  cpstate->type_stacks.emplace_back ((yyval.type_stack));
			}
#line 3241 "c-exp.c.tmp"
    break;

  case 141: /* abs_decl: ptr_operator_ts direct_abs_decl  */
#line 1220 "../../../gdb/gdb/c-exp.y"
                        { (yyval.type_stack) = (yyvsp[0].type_stack)->append ((yyvsp[-1].type_stack)); }
#line 3247 "c-exp.c.tmp"
    break;

  case 144: /* direct_abs_decl: '(' abs_decl ')'  */
#line 1226 "../../../gdb/gdb/c-exp.y"
                        { (yyval.type_stack) = (yyvsp[-1].type_stack); }
#line 3253 "c-exp.c.tmp"
    break;

  case 145: /* direct_abs_decl: direct_abs_decl array_mod  */
#line 1228 "../../../gdb/gdb/c-exp.y"
                        {
			  cpstate->type_stack.push ((yyvsp[-1].type_stack));
			  cpstate->type_stack.push ((yyvsp[0].lval));
			  cpstate->type_stack.push (tp_array);
			  (yyval.type_stack) = cpstate->type_stack.create ();
			  cpstate->type_stacks.emplace_back ((yyval.type_stack));
			}
#line 3265 "c-exp.c.tmp"
    break;

  case 146: /* direct_abs_decl: array_mod  */
#line 1236 "../../../gdb/gdb/c-exp.y"
                        {
			  cpstate->type_stack.push ((yyvsp[0].lval));
			  cpstate->type_stack.push (tp_array);
			  (yyval.type_stack) = cpstate->type_stack.create ();
			  cpstate->type_stacks.emplace_back ((yyval.type_stack));
			}
#line 3276 "c-exp.c.tmp"
    break;

  case 147: /* direct_abs_decl: direct_abs_decl func_mod  */
#line 1244 "../../../gdb/gdb/c-exp.y"
                        {
			  cpstate->type_stack.push ((yyvsp[-1].type_stack));
			  cpstate->type_stack.push ((yyvsp[0].tvec));
			  (yyval.type_stack) = cpstate->type_stack.create ();
			  cpstate->type_stacks.emplace_back ((yyval.type_stack));
			}
#line 3287 "c-exp.c.tmp"
    break;

  case 148: /* direct_abs_decl: func_mod  */
#line 1251 "../../../gdb/gdb/c-exp.y"
                        {
			  cpstate->type_stack.push ((yyvsp[0].tvec));
			  (yyval.type_stack) = cpstate->type_stack.create ();
			  cpstate->type_stacks.emplace_back ((yyval.type_stack));
			}
#line 3297 "c-exp.c.tmp"
    break;

  case 149: /* array_mod: '[' ']'  */
#line 1259 "../../../gdb/gdb/c-exp.y"
                        { (yyval.lval) = -1; }
#line 3303 "c-exp.c.tmp"
    break;

  case 150: /* array_mod: OBJC_LBRAC ']'  */
#line 1261 "../../../gdb/gdb/c-exp.y"
                        { (yyval.lval) = -1; }
#line 3309 "c-exp.c.tmp"
    break;

  case 151: /* array_mod: '[' INT ']'  */
#line 1263 "../../../gdb/gdb/c-exp.y"
                        { (yyval.lval) = (yyvsp[-1].typed_val_int).val; }
#line 3315 "c-exp.c.tmp"
    break;

  case 152: /* array_mod: OBJC_LBRAC INT ']'  */
#line 1265 "../../../gdb/gdb/c-exp.y"
                        { (yyval.lval) = (yyvsp[-1].typed_val_int).val; }
#line 3321 "c-exp.c.tmp"
    break;

  case 153: /* func_mod: '(' ')'  */
#line 1269 "../../../gdb/gdb/c-exp.y"
                        {
			  (yyval.tvec) = new std::vector<struct type *>;
			  cpstate->type_lists.emplace_back ((yyval.tvec));
			}
#line 3330 "c-exp.c.tmp"
    break;

  case 154: /* func_mod: '(' parameter_typelist ')'  */
#line 1274 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tvec) = (yyvsp[-1].tvec); }
#line 3336 "c-exp.c.tmp"
    break;

  case 156: /* typebase: TYPENAME  */
#line 1300 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = (yyvsp[0].tsym).type; }
#line 3342 "c-exp.c.tmp"
    break;

  case 157: /* typebase: INT_KEYWORD  */
#line 1302 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "int"); }
#line 3349 "c-exp.c.tmp"
    break;

  case 158: /* typebase: LONG  */
#line 1305 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long"); }
#line 3356 "c-exp.c.tmp"
    break;

  case 159: /* typebase: SHORT  */
#line 1308 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "short"); }
#line 3363 "c-exp.c.tmp"
    break;

  case 160: /* typebase: LONG INT_KEYWORD  */
#line 1311 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long"); }
#line 3370 "c-exp.c.tmp"
    break;

  case 161: /* typebase: LONG SIGNED_KEYWORD INT_KEYWORD  */
#line 1314 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long"); }
#line 3377 "c-exp.c.tmp"
    break;

  case 162: /* typebase: LONG SIGNED_KEYWORD  */
#line 1317 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long"); }
#line 3384 "c-exp.c.tmp"
    break;

  case 163: /* typebase: SIGNED_KEYWORD LONG INT_KEYWORD  */
#line 1320 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long"); }
#line 3391 "c-exp.c.tmp"
    break;

  case 164: /* typebase: UNSIGNED LONG INT_KEYWORD  */
#line 1323 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "long"); }
#line 3398 "c-exp.c.tmp"
    break;

  case 165: /* typebase: LONG UNSIGNED INT_KEYWORD  */
#line 1326 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "long"); }
#line 3405 "c-exp.c.tmp"
    break;

  case 166: /* typebase: LONG UNSIGNED  */
#line 1329 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "long"); }
#line 3412 "c-exp.c.tmp"
    break;

  case 167: /* typebase: LONG LONG  */
#line 1332 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long long"); }
#line 3419 "c-exp.c.tmp"
    break;

  case 168: /* typebase: LONG LONG INT_KEYWORD  */
#line 1335 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long long"); }
#line 3426 "c-exp.c.tmp"
    break;

  case 169: /* typebase: LONG LONG SIGNED_KEYWORD INT_KEYWORD  */
#line 1338 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long long"); }
#line 3433 "c-exp.c.tmp"
    break;

  case 170: /* typebase: LONG LONG SIGNED_KEYWORD  */
#line 1341 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long long"); }
#line 3440 "c-exp.c.tmp"
    break;

  case 171: /* typebase: SIGNED_KEYWORD LONG LONG  */
#line 1344 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long long"); }
#line 3447 "c-exp.c.tmp"
    break;

  case 172: /* typebase: SIGNED_KEYWORD LONG LONG INT_KEYWORD  */
#line 1347 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "long long"); }
#line 3454 "c-exp.c.tmp"
    break;

  case 173: /* typebase: UNSIGNED LONG LONG  */
#line 1350 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "long long"); }
#line 3461 "c-exp.c.tmp"
    break;

  case 174: /* typebase: UNSIGNED LONG LONG INT_KEYWORD  */
#line 1353 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "long long"); }
#line 3468 "c-exp.c.tmp"
    break;

  case 175: /* typebase: LONG LONG UNSIGNED  */
#line 1356 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "long long"); }
#line 3475 "c-exp.c.tmp"
    break;

  case 176: /* typebase: LONG LONG UNSIGNED INT_KEYWORD  */
#line 1359 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "long long"); }
#line 3482 "c-exp.c.tmp"
    break;

  case 177: /* typebase: SHORT INT_KEYWORD  */
#line 1362 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "short"); }
#line 3489 "c-exp.c.tmp"
    break;

  case 178: /* typebase: SHORT SIGNED_KEYWORD INT_KEYWORD  */
#line 1365 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "short"); }
#line 3496 "c-exp.c.tmp"
    break;

  case 179: /* typebase: SHORT SIGNED_KEYWORD  */
#line 1368 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "short"); }
#line 3503 "c-exp.c.tmp"
    break;

  case 180: /* typebase: UNSIGNED SHORT INT_KEYWORD  */
#line 1371 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "short"); }
#line 3510 "c-exp.c.tmp"
    break;

  case 181: /* typebase: SHORT UNSIGNED  */
#line 1374 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "short"); }
#line 3517 "c-exp.c.tmp"
    break;

  case 182: /* typebase: SHORT UNSIGNED INT_KEYWORD  */
#line 1377 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "short"); }
#line 3524 "c-exp.c.tmp"
    break;

  case 183: /* typebase: DOUBLE_KEYWORD  */
#line 1380 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_typename (pstate->language (),
						"double",
						NULL,
						0); }
#line 3533 "c-exp.c.tmp"
    break;

  case 184: /* typebase: LONG DOUBLE_KEYWORD  */
#line 1385 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_typename (pstate->language (),
						"long double",
						NULL,
						0); }
#line 3542 "c-exp.c.tmp"
    break;

  case 185: /* typebase: STRUCT name  */
#line 1390 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval)
			    = lookup_struct (copy_name ((yyvsp[0].sval)).c_str (),
					     pstate->expression_context_block);
			}
#line 3551 "c-exp.c.tmp"
    break;

  case 186: /* typebase: STRUCT COMPLETE  */
#line 1395 "../../../gdb/gdb/c-exp.y"
                        {
			  pstate->mark_completion_tag (TYPE_CODE_STRUCT,
						       "", 0);
			  (yyval.tval) = NULL;
			}
#line 3561 "c-exp.c.tmp"
    break;

  case 187: /* typebase: STRUCT name COMPLETE  */
#line 1401 "../../../gdb/gdb/c-exp.y"
                        {
			  pstate->mark_completion_tag (TYPE_CODE_STRUCT,
						       (yyvsp[-1].sval).ptr, (yyvsp[-1].sval).length);
			  (yyval.tval) = NULL;
			}
#line 3571 "c-exp.c.tmp"
    break;

  case 188: /* typebase: CLASS name  */
#line 1407 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_struct
			    (copy_name ((yyvsp[0].sval)).c_str (),
			     pstate->expression_context_block);
			}
#line 3580 "c-exp.c.tmp"
    break;

  case 189: /* typebase: CLASS COMPLETE  */
#line 1412 "../../../gdb/gdb/c-exp.y"
                        {
			  pstate->mark_completion_tag (TYPE_CODE_STRUCT,
						       "", 0);
			  (yyval.tval) = NULL;
			}
#line 3590 "c-exp.c.tmp"
    break;

  case 190: /* typebase: CLASS name COMPLETE  */
#line 1418 "../../../gdb/gdb/c-exp.y"
                        {
			  pstate->mark_completion_tag (TYPE_CODE_STRUCT,
						       (yyvsp[-1].sval).ptr, (yyvsp[-1].sval).length);
			  (yyval.tval) = NULL;
			}
#line 3600 "c-exp.c.tmp"
    break;

  case 191: /* typebase: UNION name  */
#line 1424 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval)
			    = lookup_union (copy_name ((yyvsp[0].sval)).c_str (),
					    pstate->expression_context_block);
			}
#line 3609 "c-exp.c.tmp"
    break;

  case 192: /* typebase: UNION COMPLETE  */
#line 1429 "../../../gdb/gdb/c-exp.y"
                        {
			  pstate->mark_completion_tag (TYPE_CODE_UNION,
						       "", 0);
			  (yyval.tval) = NULL;
			}
#line 3619 "c-exp.c.tmp"
    break;

  case 193: /* typebase: UNION name COMPLETE  */
#line 1435 "../../../gdb/gdb/c-exp.y"
                        {
			  pstate->mark_completion_tag (TYPE_CODE_UNION,
						       (yyvsp[-1].sval).ptr, (yyvsp[-1].sval).length);
			  (yyval.tval) = NULL;
			}
#line 3629 "c-exp.c.tmp"
    break;

  case 194: /* typebase: ENUM name  */
#line 1441 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_enum (copy_name ((yyvsp[0].sval)).c_str (),
					    pstate->expression_context_block);
			}
#line 3637 "c-exp.c.tmp"
    break;

  case 195: /* typebase: ENUM COMPLETE  */
#line 1445 "../../../gdb/gdb/c-exp.y"
                        {
			  pstate->mark_completion_tag (TYPE_CODE_ENUM, "", 0);
			  (yyval.tval) = NULL;
			}
#line 3646 "c-exp.c.tmp"
    break;

  case 196: /* typebase: ENUM name COMPLETE  */
#line 1450 "../../../gdb/gdb/c-exp.y"
                        {
			  pstate->mark_completion_tag (TYPE_CODE_ENUM, (yyvsp[-1].sval).ptr,
						       (yyvsp[-1].sval).length);
			  (yyval.tval) = NULL;
			}
#line 3656 "c-exp.c.tmp"
    break;

  case 197: /* typebase: UNSIGNED type_name  */
#line 1456 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 TYPE_NAME((yyvsp[0].tsym).type)); }
#line 3663 "c-exp.c.tmp"
    break;

  case 198: /* typebase: UNSIGNED  */
#line 1459 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_unsigned_typename (pstate->language (),
							 "int"); }
#line 3670 "c-exp.c.tmp"
    break;

  case 199: /* typebase: SIGNED_KEYWORD type_name  */
#line 1462 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       TYPE_NAME((yyvsp[0].tsym).type)); }
#line 3677 "c-exp.c.tmp"
    break;

  case 200: /* typebase: SIGNED_KEYWORD  */
#line 1465 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_signed_typename (pstate->language (),
						       "int"); }
#line 3684 "c-exp.c.tmp"
    break;

  case 201: /* typebase: TEMPLATE name '<' type '>'  */
#line 1471 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = lookup_template_type
			    (copy_name((yyvsp[-3].sval)).c_str (), (yyvsp[-1].tval),
			     pstate->expression_context_block);
			}
#line 3693 "c-exp.c.tmp"
    break;

  case 202: /* typebase: const_or_volatile_or_space_identifier_noopt typebase  */
#line 1476 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = cpstate->type_stack.follow_types ((yyvsp[0].tval)); }
#line 3699 "c-exp.c.tmp"
    break;

  case 203: /* typebase: typebase const_or_volatile_or_space_identifier_noopt  */
#line 1478 "../../../gdb/gdb/c-exp.y"
                        { (yyval.tval) = cpstate->type_stack.follow_types ((yyvsp[-1].tval)); }
#line 3705 "c-exp.c.tmp"
    break;

  case 205: /* type_name: INT_KEYWORD  */
#line 1483 "../../../gdb/gdb/c-exp.y"
                {
		  (yyval.tsym).stoken.ptr = "int";
		  (yyval.tsym).stoken.length = 3;
		  (yyval.tsym).type = lookup_signed_typename (pstate->language (),
						    "int");
		}
#line 3716 "c-exp.c.tmp"
    break;

  case 206: /* type_name: LONG  */
#line 1490 "../../../gdb/gdb/c-exp.y"
                {
		  (yyval.tsym).stoken.ptr = "long";
		  (yyval.tsym).stoken.length = 4;
		  (yyval.tsym).type = lookup_signed_typename (pstate->language (),
						    "long");
		}
#line 3727 "c-exp.c.tmp"
    break;

  case 207: /* type_name: SHORT  */
#line 1497 "../../../gdb/gdb/c-exp.y"
                {
		  (yyval.tsym).stoken.ptr = "short";
		  (yyval.tsym).stoken.length = 5;
		  (yyval.tsym).type = lookup_signed_typename (pstate->language (),
						    "short");
		}
#line 3738 "c-exp.c.tmp"
    break;

  case 208: /* parameter_typelist: nonempty_typelist  */
#line 1507 "../../../gdb/gdb/c-exp.y"
                        { check_parameter_typelist ((yyvsp[0].tvec)); }
#line 3744 "c-exp.c.tmp"
    break;

  case 209: /* parameter_typelist: nonempty_typelist ',' DOTDOTDOT  */
#line 1509 "../../../gdb/gdb/c-exp.y"
                        {
			  (yyvsp[-2].tvec)->push_back (NULL);
			  check_parameter_typelist ((yyvsp[-2].tvec));
			  (yyval.tvec) = (yyvsp[-2].tvec);
			}
#line 3754 "c-exp.c.tmp"
    break;

  case 210: /* nonempty_typelist: type  */
#line 1518 "../../../gdb/gdb/c-exp.y"
                {
		  std::vector<struct type *> *typelist
		    = new std::vector<struct type *>;
		  cpstate->type_lists.emplace_back (typelist);

		  typelist->push_back ((yyvsp[0].tval));
		  (yyval.tvec) = typelist;
		}
#line 3767 "c-exp.c.tmp"
    break;

  case 211: /* nonempty_typelist: nonempty_typelist ',' type  */
#line 1527 "../../../gdb/gdb/c-exp.y"
                {
		  (yyvsp[-2].tvec)->push_back ((yyvsp[0].tval));
		  (yyval.tvec) = (yyvsp[-2].tvec);
		}
#line 3776 "c-exp.c.tmp"
    break;

  case 213: /* ptype: ptype abs_decl  */
#line 1535 "../../../gdb/gdb/c-exp.y"
                {
		  cpstate->type_stack.push ((yyvsp[0].type_stack));
		  (yyval.tval) = cpstate->type_stack.follow_types ((yyvsp[-1].tval));
		}
#line 3785 "c-exp.c.tmp"
    break;

  case 214: /* conversion_type_id: typebase conversion_declarator  */
#line 1542 "../../../gdb/gdb/c-exp.y"
                { (yyval.tval) = cpstate->type_stack.follow_types ((yyvsp[-1].tval)); }
#line 3791 "c-exp.c.tmp"
    break;

  case 219: /* const_or_volatile_noopt: const_and_volatile  */
#line 1554 "../../../gdb/gdb/c-exp.y"
                        { cpstate->type_stack.insert (tp_const);
			  cpstate->type_stack.insert (tp_volatile);
			}
#line 3799 "c-exp.c.tmp"
    break;

  case 220: /* const_or_volatile_noopt: CONST_KEYWORD  */
#line 1558 "../../../gdb/gdb/c-exp.y"
                        { cpstate->type_stack.insert (tp_const); }
#line 3805 "c-exp.c.tmp"
    break;

  case 221: /* const_or_volatile_noopt: VOLATILE_KEYWORD  */
#line 1560 "../../../gdb/gdb/c-exp.y"
                        { cpstate->type_stack.insert (tp_volatile); }
#line 3811 "c-exp.c.tmp"
    break;

  case 222: /* oper: OPERATOR NEW  */
#line 1564 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken (" new"); }
#line 3817 "c-exp.c.tmp"
    break;

  case 223: /* oper: OPERATOR DELETE  */
#line 1566 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken (" delete"); }
#line 3823 "c-exp.c.tmp"
    break;

  case 224: /* oper: OPERATOR NEW '[' ']'  */
#line 1568 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken (" new[]"); }
#line 3829 "c-exp.c.tmp"
    break;

  case 225: /* oper: OPERATOR DELETE '[' ']'  */
#line 1570 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken (" delete[]"); }
#line 3835 "c-exp.c.tmp"
    break;

  case 226: /* oper: OPERATOR NEW OBJC_LBRAC ']'  */
#line 1572 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken (" new[]"); }
#line 3841 "c-exp.c.tmp"
    break;

  case 227: /* oper: OPERATOR DELETE OBJC_LBRAC ']'  */
#line 1574 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken (" delete[]"); }
#line 3847 "c-exp.c.tmp"
    break;

  case 228: /* oper: OPERATOR '+'  */
#line 1576 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("+"); }
#line 3853 "c-exp.c.tmp"
    break;

  case 229: /* oper: OPERATOR '-'  */
#line 1578 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("-"); }
#line 3859 "c-exp.c.tmp"
    break;

  case 230: /* oper: OPERATOR '*'  */
#line 1580 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("*"); }
#line 3865 "c-exp.c.tmp"
    break;

  case 231: /* oper: OPERATOR '/'  */
#line 1582 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("/"); }
#line 3871 "c-exp.c.tmp"
    break;

  case 232: /* oper: OPERATOR '%'  */
#line 1584 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("%"); }
#line 3877 "c-exp.c.tmp"
    break;

  case 233: /* oper: OPERATOR '^'  */
#line 1586 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("^"); }
#line 3883 "c-exp.c.tmp"
    break;

  case 234: /* oper: OPERATOR '&'  */
#line 1588 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("&"); }
#line 3889 "c-exp.c.tmp"
    break;

  case 235: /* oper: OPERATOR '|'  */
#line 1590 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("|"); }
#line 3895 "c-exp.c.tmp"
    break;

  case 236: /* oper: OPERATOR '~'  */
#line 1592 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("~"); }
#line 3901 "c-exp.c.tmp"
    break;

  case 237: /* oper: OPERATOR '!'  */
#line 1594 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("!"); }
#line 3907 "c-exp.c.tmp"
    break;

  case 238: /* oper: OPERATOR '='  */
#line 1596 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("="); }
#line 3913 "c-exp.c.tmp"
    break;

  case 239: /* oper: OPERATOR '<'  */
#line 1598 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("<"); }
#line 3919 "c-exp.c.tmp"
    break;

  case 240: /* oper: OPERATOR '>'  */
#line 1600 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken (">"); }
#line 3925 "c-exp.c.tmp"
    break;

  case 241: /* oper: OPERATOR ASSIGN_MODIFY  */
#line 1602 "../../../gdb/gdb/c-exp.y"
                        { const char *op = " unknown";
			  switch ((yyvsp[0].opcode))
			    {
			    case BINOP_RSH:
			      op = ">>=";
			      break;
			    case BINOP_LSH:
			      op = "<<=";
			      break;
			    case BINOP_ADD:
			      op = "+=";
			      break;
			    case BINOP_SUB:
			      op = "-=";
			      break;
			    case BINOP_MUL:
			      op = "*=";
			      break;
			    case BINOP_DIV:
			      op = "/=";
			      break;
			    case BINOP_REM:
			      op = "%=";
			      break;
			    case BINOP_BITWISE_IOR:
			      op = "|=";
			      break;
			    case BINOP_BITWISE_AND:
			      op = "&=";
			      break;
			    case BINOP_BITWISE_XOR:
			      op = "^=";
			      break;
			    default:
			      break;
			    }

			  (yyval.sval) = operator_stoken (op);
			}
#line 3969 "c-exp.c.tmp"
    break;

  case 242: /* oper: OPERATOR LSH  */
#line 1642 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("<<"); }
#line 3975 "c-exp.c.tmp"
    break;

  case 243: /* oper: OPERATOR RSH  */
#line 1644 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken (">>"); }
#line 3981 "c-exp.c.tmp"
    break;

  case 244: /* oper: OPERATOR EQUAL  */
#line 1646 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("=="); }
#line 3987 "c-exp.c.tmp"
    break;

  case 245: /* oper: OPERATOR NOTEQUAL  */
#line 1648 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("!="); }
#line 3993 "c-exp.c.tmp"
    break;

  case 246: /* oper: OPERATOR LEQ  */
#line 1650 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("<="); }
#line 3999 "c-exp.c.tmp"
    break;

  case 247: /* oper: OPERATOR GEQ  */
#line 1652 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken (">="); }
#line 4005 "c-exp.c.tmp"
    break;

  case 248: /* oper: OPERATOR ANDAND  */
#line 1654 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("&&"); }
#line 4011 "c-exp.c.tmp"
    break;

  case 249: /* oper: OPERATOR OROR  */
#line 1656 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("||"); }
#line 4017 "c-exp.c.tmp"
    break;

  case 250: /* oper: OPERATOR INCREMENT  */
#line 1658 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("++"); }
#line 4023 "c-exp.c.tmp"
    break;

  case 251: /* oper: OPERATOR DECREMENT  */
#line 1660 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("--"); }
#line 4029 "c-exp.c.tmp"
    break;

  case 252: /* oper: OPERATOR ','  */
#line 1662 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken (","); }
#line 4035 "c-exp.c.tmp"
    break;

  case 253: /* oper: OPERATOR ARROW_STAR  */
#line 1664 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("->*"); }
#line 4041 "c-exp.c.tmp"
    break;

  case 254: /* oper: OPERATOR ARROW  */
#line 1666 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("->"); }
#line 4047 "c-exp.c.tmp"
    break;

  case 255: /* oper: OPERATOR '(' ')'  */
#line 1668 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("()"); }
#line 4053 "c-exp.c.tmp"
    break;

  case 256: /* oper: OPERATOR '[' ']'  */
#line 1670 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("[]"); }
#line 4059 "c-exp.c.tmp"
    break;

  case 257: /* oper: OPERATOR OBJC_LBRAC ']'  */
#line 1672 "../../../gdb/gdb/c-exp.y"
                        { (yyval.sval) = operator_stoken ("[]"); }
#line 4065 "c-exp.c.tmp"
    break;

  case 258: /* oper: OPERATOR conversion_type_id  */
#line 1674 "../../../gdb/gdb/c-exp.y"
                        { string_file buf;

			  c_print_type ((yyvsp[0].tval), NULL, &buf, -1, 0,
					&type_print_raw_options);

			  /* This also needs canonicalization.  */
			  std::string canon
			    = cp_canonicalize_string (buf.c_str ());
			  if (canon.empty ())
			    canon = std::move (buf.string ());
			  (yyval.sval) = operator_stoken ((" " + canon).c_str ());
			}
#line 4082 "c-exp.c.tmp"
    break;

  case 260: /* field_name: DOUBLE_KEYWORD  */
#line 1697 "../../../gdb/gdb/c-exp.y"
                               { (yyval.sval) = typename_stoken ("double"); }
#line 4088 "c-exp.c.tmp"
    break;

  case 261: /* field_name: INT_KEYWORD  */
#line 1698 "../../../gdb/gdb/c-exp.y"
                            { (yyval.sval) = typename_stoken ("int"); }
#line 4094 "c-exp.c.tmp"
    break;

  case 262: /* field_name: LONG  */
#line 1699 "../../../gdb/gdb/c-exp.y"
                     { (yyval.sval) = typename_stoken ("long"); }
#line 4100 "c-exp.c.tmp"
    break;

  case 263: /* field_name: SHORT  */
#line 1700 "../../../gdb/gdb/c-exp.y"
                      { (yyval.sval) = typename_stoken ("short"); }
#line 4106 "c-exp.c.tmp"
    break;

  case 264: /* field_name: SIGNED_KEYWORD  */
#line 1701 "../../../gdb/gdb/c-exp.y"
                               { (yyval.sval) = typename_stoken ("signed"); }
#line 4112 "c-exp.c.tmp"
    break;

  case 265: /* field_name: UNSIGNED  */
#line 1702 "../../../gdb/gdb/c-exp.y"
                         { (yyval.sval) = typename_stoken ("unsigned"); }
#line 4118 "c-exp.c.tmp"
    break;

  case 266: /* name: NAME  */
#line 1705 "../../../gdb/gdb/c-exp.y"
                     { (yyval.sval) = (yyvsp[0].ssym).stoken; }
#line 4124 "c-exp.c.tmp"
    break;

  case 267: /* name: BLOCKNAME  */
#line 1706 "../../../gdb/gdb/c-exp.y"
                          { (yyval.sval) = (yyvsp[0].ssym).stoken; }
#line 4130 "c-exp.c.tmp"
    break;

  case 268: /* name: TYPENAME  */
#line 1707 "../../../gdb/gdb/c-exp.y"
                         { (yyval.sval) = (yyvsp[0].tsym).stoken; }
#line 4136 "c-exp.c.tmp"
    break;

  case 269: /* name: NAME_OR_INT  */
#line 1708 "../../../gdb/gdb/c-exp.y"
                             { (yyval.sval) = (yyvsp[0].ssym).stoken; }
#line 4142 "c-exp.c.tmp"
    break;

  case 270: /* name: UNKNOWN_CPP_NAME  */
#line 1709 "../../../gdb/gdb/c-exp.y"
                                  { (yyval.sval) = (yyvsp[0].ssym).stoken; }
#line 4148 "c-exp.c.tmp"
    break;

  case 271: /* name: oper  */
#line 1710 "../../../gdb/gdb/c-exp.y"
                     { (yyval.sval) = (yyvsp[0].sval); }
#line 4154 "c-exp.c.tmp"
    break;

  case 274: /* name_not_typename: oper  */
#line 1723 "../../../gdb/gdb/c-exp.y"
                        {
			  struct field_of_this_result is_a_field_of_this;

			  (yyval.ssym).stoken = (yyvsp[0].sval);
			  (yyval.ssym).sym
			    = lookup_symbol ((yyvsp[0].sval).ptr,
					     pstate->expression_context_block,
					     VAR_DOMAIN,
					     &is_a_field_of_this);
			  (yyval.ssym).is_a_field_of_this
			    = is_a_field_of_this.type != NULL;
			}
#line 4171 "c-exp.c.tmp"
    break;


#line 4175 "c-exp.c.tmp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1738 "../../../gdb/gdb/c-exp.y"


/* Like write_exp_string, but prepends a '~'.  */

static void
write_destructor_name (struct parser_state *par_state, struct stoken token)
{
  char *copy = (char *) alloca (token.length + 1);

  copy[0] = '~';
  memcpy (&copy[1], token.ptr, token.length);

  token.ptr = copy;
  ++token.length;

  write_exp_string (par_state, token);
}

/* Returns a stoken of the operator name given by OP (which does not
   include the string "operator").  */

static struct stoken
operator_stoken (const char *op)
{
  struct stoken st = { NULL, 0 };
  char *buf;

  st.length = CP_OPERATOR_LEN + strlen (op);
  buf = (char *) xmalloc (st.length + 1);
  strcpy (buf, CP_OPERATOR_STR);
  strcat (buf, op);
  st.ptr = buf;

  /* The toplevel (c_parse) will free the memory allocated here.  */
  cpstate->strings.emplace_back (buf);
  return st;
};

/* Returns a stoken of the type named TYPE.  */

static struct stoken
typename_stoken (const char *type)
{
  struct stoken st = { type, 0 };
  st.length = strlen (type);
  return st;
};

/* Return true if the type is aggregate-like.  */

static int
type_aggregate_p (struct type *type)
{
  return (TYPE_CODE (type) == TYPE_CODE_STRUCT
	  || TYPE_CODE (type) == TYPE_CODE_UNION
	  || TYPE_CODE (type) == TYPE_CODE_NAMESPACE
	  || (TYPE_CODE (type) == TYPE_CODE_ENUM
	      && TYPE_DECLARED_CLASS (type)));
}

/* Validate a parameter typelist.  */

static void
check_parameter_typelist (std::vector<struct type *> *params)
{
  struct type *type;
  int ix;

  for (ix = 0; ix < params->size (); ++ix)
    {
      type = (*params)[ix];
      if (type != NULL && TYPE_CODE (check_typedef (type)) == TYPE_CODE_VOID)
	{
	  if (ix == 0)
	    {
	      if (params->size () == 1)
		{
		  /* Ok.  */
		  break;
		}
	      error (_("parameter types following 'void'"));
	    }
	  else
	    error (_("'void' invalid as parameter type"));
	}
    }
}

/* Take care of parsing a number (anything that starts with a digit).
   Set yylval and return the token type; update lexptr.
   LEN is the number of characters in it.  */

/*** Needs some error checking for the float case ***/

static int
parse_number (struct parser_state *par_state,
	      const char *buf, int len, int parsed_float, YYSTYPE *putithere)
{
  ULONGEST n = 0;
  ULONGEST prevn = 0;
  ULONGEST un;

  int i = 0;
  int c;
  int base = input_radix;
  int unsigned_p = 0;

  /* Number of "L" suffixes encountered.  */
  int long_p = 0;

  /* We have found a "L" or "U" suffix.  */
  int found_suffix = 0;

  ULONGEST high_bit;
  struct type *signed_type;
  struct type *unsigned_type;
  char *p;

  p = (char *) alloca (len);
  memcpy (p, buf, len);

  if (parsed_float)
    {
      /* Handle suffixes for decimal floating-point: "df", "dd" or "dl".  */
      if (len >= 2 && p[len - 2] == 'd' && p[len - 1] == 'f')
	{
	  putithere->typed_val_float.type
	    = parse_type (par_state)->builtin_decfloat;
	  len -= 2;
	}
      else if (len >= 2 && p[len - 2] == 'd' && p[len - 1] == 'd')
	{
	  putithere->typed_val_float.type
	    = parse_type (par_state)->builtin_decdouble;
	  len -= 2;
	}
      else if (len >= 2 && p[len - 2] == 'd' && p[len - 1] == 'l')
	{
	  putithere->typed_val_float.type
	    = parse_type (par_state)->builtin_declong;
	  len -= 2;
	}
      /* Handle suffixes: 'f' for float, 'l' for long double.  */
      else if (len >= 1 && TOLOWER (p[len - 1]) == 'f')
	{
	  putithere->typed_val_float.type
	    = parse_type (par_state)->builtin_float;
	  len -= 1;
	}
      else if (len >= 1 && TOLOWER (p[len - 1]) == 'l')
	{
	  putithere->typed_val_float.type
	    = parse_type (par_state)->builtin_long_double;
	  len -= 1;
	}
      /* Default type for floating-point literals is double.  */
      else
	{
	  putithere->typed_val_float.type
	    = parse_type (par_state)->builtin_double;
	}

      if (!parse_float (p, len,
			putithere->typed_val_float.type,
			putithere->typed_val_float.val))
        return ERROR;
      return FLOAT;
    }

  /* Handle base-switching prefixes 0x, 0t, 0d, 0 */
  if (p[0] == '0' && len > 1)
    switch (p[1])
      {
      case 'x':
      case 'X':
	if (len >= 3)
	  {
	    p += 2;
	    base = 16;
	    len -= 2;
	  }
	break;

      case 'b':
      case 'B':
	if (len >= 3)
	  {
	    p += 2;
	    base = 2;
	    len -= 2;
	  }
	break;

      case 't':
      case 'T':
      case 'd':
      case 'D':
	if (len >= 3)
	  {
	    p += 2;
	    base = 10;
	    len -= 2;
	  }
	break;

      default:
	base = 8;
	break;
      }

  while (len-- > 0)
    {
      c = *p++;
      if (c >= 'A' && c <= 'Z')
	c += 'a' - 'A';
      if (c != 'l' && c != 'u')
	n *= base;
      if (c >= '0' && c <= '9')
	{
	  if (found_suffix)
	    return ERROR;
	  n += i = c - '0';
	}
      else
	{
	  if (base > 10 && c >= 'a' && c <= 'f')
	    {
	      if (found_suffix)
		return ERROR;
	      n += i = c - 'a' + 10;
	    }
	  else if (c == 'l')
	    {
	      ++long_p;
	      found_suffix = 1;
	    }
	  else if (c == 'u')
	    {
	      unsigned_p = 1;
	      found_suffix = 1;
	    }
	  else
	    return ERROR;	/* Char not a digit */
	}
      if (i >= base)
	return ERROR;		/* Invalid digit in this base */

      /* Portably test for overflow (only works for nonzero values, so make
	 a second check for zero).  FIXME: Can't we just make n and prevn
	 unsigned and avoid this?  */
      if (c != 'l' && c != 'u' && (prevn >= n) && n != 0)
	unsigned_p = 1;		/* Try something unsigned */

      /* Portably test for unsigned overflow.
	 FIXME: This check is wrong; for example it doesn't find overflow
	 on 0x123456789 when LONGEST is 32 bits.  */
      if (c != 'l' && c != 'u' && n != 0)
	{	
	  if (unsigned_p && prevn >= n)
	    error (_("Numeric constant too large."));
	}
      prevn = n;
    }

  /* An integer constant is an int, a long, or a long long.  An L
     suffix forces it to be long; an LL suffix forces it to be long
     long.  If not forced to a larger size, it gets the first type of
     the above that it fits in.  To figure out whether it fits, we
     shift it right and see whether anything remains.  Note that we
     can't shift sizeof (LONGEST) * HOST_CHAR_BIT bits or more in one
     operation, because many compilers will warn about such a shift
     (which always produces a zero result).  Sometimes gdbarch_int_bit
     or gdbarch_long_bit will be that big, sometimes not.  To deal with
     the case where it is we just always shift the value more than
     once, with fewer bits each time.  */

  un = n >> 2;
  if (long_p == 0
      && (un >> (gdbarch_int_bit (par_state->gdbarch ()) - 2)) == 0)
    {
      high_bit
	= ((ULONGEST)1) << (gdbarch_int_bit (par_state->gdbarch ()) - 1);

      /* A large decimal (not hex or octal) constant (between INT_MAX
	 and UINT_MAX) is a long or unsigned long, according to ANSI,
	 never an unsigned int, but this code treats it as unsigned
	 int.  This probably should be fixed.  GCC gives a warning on
	 such constants.  */

      unsigned_type = parse_type (par_state)->builtin_unsigned_int;
      signed_type = parse_type (par_state)->builtin_int;
    }
  else if (long_p <= 1
	   && (un >> (gdbarch_long_bit (par_state->gdbarch ()) - 2)) == 0)
    {
      high_bit
	= ((ULONGEST)1) << (gdbarch_long_bit (par_state->gdbarch ()) - 1);
      unsigned_type = parse_type (par_state)->builtin_unsigned_long;
      signed_type = parse_type (par_state)->builtin_long;
    }
  else
    {
      int shift;
      if (sizeof (ULONGEST) * HOST_CHAR_BIT
	  < gdbarch_long_long_bit (par_state->gdbarch ()))
	/* A long long does not fit in a LONGEST.  */
	shift = (sizeof (ULONGEST) * HOST_CHAR_BIT - 1);
      else
	shift = (gdbarch_long_long_bit (par_state->gdbarch ()) - 1);
      high_bit = (ULONGEST) 1 << shift;
      unsigned_type = parse_type (par_state)->builtin_unsigned_long_long;
      signed_type = parse_type (par_state)->builtin_long_long;
    }

   putithere->typed_val_int.val = n;

   /* If the high bit of the worked out type is set then this number
      has to be unsigned. */

   if (unsigned_p || (n & high_bit))
     {
       putithere->typed_val_int.type = unsigned_type;
     }
   else
     {
       putithere->typed_val_int.type = signed_type;
     }

   return INT;
}

/* Temporary obstack used for holding strings.  */
static struct obstack tempbuf;
static int tempbuf_init;

/* Parse a C escape sequence.  The initial backslash of the sequence
   is at (*PTR)[-1].  *PTR will be updated to point to just after the
   last character of the sequence.  If OUTPUT is not NULL, the
   translated form of the escape sequence will be written there.  If
   OUTPUT is NULL, no output is written and the call will only affect
   *PTR.  If an escape sequence is expressed in target bytes, then the
   entire sequence will simply be copied to OUTPUT.  Return 1 if any
   character was emitted, 0 otherwise.  */

int
c_parse_escape (const char **ptr, struct obstack *output)
{
  const char *tokptr = *ptr;
  int result = 1;

  /* Some escape sequences undergo character set conversion.  Those we
     translate here.  */
  switch (*tokptr)
    {
      /* Hex escapes do not undergo character set conversion, so keep
	 the escape sequence for later.  */
    case 'x':
      if (output)
	obstack_grow_str (output, "\\x");
      ++tokptr;
      if (!ISXDIGIT (*tokptr))
	error (_("\\x escape without a following hex digit"));
      while (ISXDIGIT (*tokptr))
	{
	  if (output)
	    obstack_1grow (output, *tokptr);
	  ++tokptr;
	}
      break;

      /* Octal escapes do not undergo character set conversion, so
	 keep the escape sequence for later.  */
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
      {
	int i;
	if (output)
	  obstack_grow_str (output, "\\");
	for (i = 0;
	     i < 3 && ISDIGIT (*tokptr) && *tokptr != '8' && *tokptr != '9';
	     ++i)
	  {
	    if (output)
	      obstack_1grow (output, *tokptr);
	    ++tokptr;
	  }
      }
      break;

      /* We handle UCNs later.  We could handle them here, but that
	 would mean a spurious error in the case where the UCN could
	 be converted to the target charset but not the host
	 charset.  */
    case 'u':
    case 'U':
      {
	char c = *tokptr;
	int i, len = c == 'U' ? 8 : 4;
	if (output)
	  {
	    obstack_1grow (output, '\\');
	    obstack_1grow (output, *tokptr);
	  }
	++tokptr;
	if (!ISXDIGIT (*tokptr))
	  error (_("\\%c escape without a following hex digit"), c);
	for (i = 0; i < len && ISXDIGIT (*tokptr); ++i)
	  {
	    if (output)
	      obstack_1grow (output, *tokptr);
	    ++tokptr;
	  }
      }
      break;

      /* We must pass backslash through so that it does not
	 cause quoting during the second expansion.  */
    case '\\':
      if (output)
	obstack_grow_str (output, "\\\\");
      ++tokptr;
      break;

      /* Escapes which undergo conversion.  */
    case 'a':
      if (output)
	obstack_1grow (output, '\a');
      ++tokptr;
      break;
    case 'b':
      if (output)
	obstack_1grow (output, '\b');
      ++tokptr;
      break;
    case 'f':
      if (output)
	obstack_1grow (output, '\f');
      ++tokptr;
      break;
    case 'n':
      if (output)
	obstack_1grow (output, '\n');
      ++tokptr;
      break;
    case 'r':
      if (output)
	obstack_1grow (output, '\r');
      ++tokptr;
      break;
    case 't':
      if (output)
	obstack_1grow (output, '\t');
      ++tokptr;
      break;
    case 'v':
      if (output)
	obstack_1grow (output, '\v');
      ++tokptr;
      break;

      /* GCC extension.  */
    case 'e':
      if (output)
	obstack_1grow (output, HOST_ESCAPE_CHAR);
      ++tokptr;
      break;

      /* Backslash-newline expands to nothing at all.  */
    case '\n':
      ++tokptr;
      result = 0;
      break;

      /* A few escapes just expand to the character itself.  */
    case '\'':
    case '\"':
    case '?':
      /* GCC extensions.  */
    case '(':
    case '{':
    case '[':
    case '%':
      /* Unrecognized escapes turn into the character itself.  */
    default:
      if (output)
	obstack_1grow (output, *tokptr);
      ++tokptr;
      break;
    }
  *ptr = tokptr;
  return result;
}

/* Parse a string or character literal from TOKPTR.  The string or
   character may be wide or unicode.  *OUTPTR is set to just after the
   end of the literal in the input string.  The resulting token is
   stored in VALUE.  This returns a token value, either STRING or
   CHAR, depending on what was parsed.  *HOST_CHARS is set to the
   number of host characters in the literal.  */

static int
parse_string_or_char (const char *tokptr, const char **outptr,
		      struct typed_stoken *value, int *host_chars)
{
  int quote;
  c_string_type type;
  int is_objc = 0;

  /* Build the gdb internal form of the input string in tempbuf.  Note
     that the buffer is null byte terminated *only* for the
     convenience of debugging gdb itself and printing the buffer
     contents when the buffer contains no embedded nulls.  Gdb does
     not depend upon the buffer being null byte terminated, it uses
     the length string instead.  This allows gdb to handle C strings
     (as well as strings in other languages) with embedded null
     bytes */

  if (!tempbuf_init)
    tempbuf_init = 1;
  else
    obstack_free (&tempbuf, NULL);
  obstack_init (&tempbuf);

  /* Record the string type.  */
  if (*tokptr == 'L')
    {
      type = C_WIDE_STRING;
      ++tokptr;
    }
  else if (*tokptr == 'u')
    {
      type = C_STRING_16;
      ++tokptr;
    }
  else if (*tokptr == 'U')
    {
      type = C_STRING_32;
      ++tokptr;
    }
  else if (*tokptr == '@')
    {
      /* An Objective C string.  */
      is_objc = 1;
      type = C_STRING;
      ++tokptr;
    }
  else
    type = C_STRING;

  /* Skip the quote.  */
  quote = *tokptr;
  if (quote == '\'')
    type |= C_CHAR;
  ++tokptr;

  *host_chars = 0;

  while (*tokptr)
    {
      char c = *tokptr;
      if (c == '\\')
	{
	  ++tokptr;
	  *host_chars += c_parse_escape (&tokptr, &tempbuf);
	}
      else if (c == quote)
	break;
      else
	{
	  obstack_1grow (&tempbuf, c);
	  ++tokptr;
	  /* FIXME: this does the wrong thing with multi-byte host
	     characters.  We could use mbrlen here, but that would
	     make "set host-charset" a bit less useful.  */
	  ++*host_chars;
	}
    }

  if (*tokptr != quote)
    {
      if (quote == '"')
	error (_("Unterminated string in expression."));
      else
	error (_("Unmatched single quote."));
    }
  ++tokptr;

  value->type = type;
  value->ptr = (char *) obstack_base (&tempbuf);
  value->length = obstack_object_size (&tempbuf);

  *outptr = tokptr;

  return quote == '"' ? (is_objc ? NSSTRING : STRING) : CHAR;
}

/* This is used to associate some attributes with a token.  */

enum token_flag
{
  /* If this bit is set, the token is C++-only.  */

  FLAG_CXX = 1,

  /* If this bit is set, the token is conditional: if there is a
     symbol of the same name, then the token is a symbol; otherwise,
     the token is a keyword.  */

  FLAG_SHADOW = 2
};
DEF_ENUM_FLAGS_TYPE (enum token_flag, token_flags);

struct token
{
  const char *oper;
  int token;
  enum exp_opcode opcode;
  token_flags flags;
};

static const struct token tokentab3[] =
  {
    {">>=", ASSIGN_MODIFY, BINOP_RSH, 0},
    {"<<=", ASSIGN_MODIFY, BINOP_LSH, 0},
    {"->*", ARROW_STAR, BINOP_END, FLAG_CXX},
    {"...", DOTDOTDOT, BINOP_END, 0}
  };

static const struct token tokentab2[] =
  {
    {"+=", ASSIGN_MODIFY, BINOP_ADD, 0},
    {"-=", ASSIGN_MODIFY, BINOP_SUB, 0},
    {"*=", ASSIGN_MODIFY, BINOP_MUL, 0},
    {"/=", ASSIGN_MODIFY, BINOP_DIV, 0},
    {"%=", ASSIGN_MODIFY, BINOP_REM, 0},
    {"|=", ASSIGN_MODIFY, BINOP_BITWISE_IOR, 0},
    {"&=", ASSIGN_MODIFY, BINOP_BITWISE_AND, 0},
    {"^=", ASSIGN_MODIFY, BINOP_BITWISE_XOR, 0},
    {"++", INCREMENT, BINOP_END, 0},
    {"--", DECREMENT, BINOP_END, 0},
    {"->", ARROW, BINOP_END, 0},
    {"&&", ANDAND, BINOP_END, 0},
    {"||", OROR, BINOP_END, 0},
    /* "::" is *not* only C++: gdb overrides its meaning in several
       different ways, e.g., 'filename'::func, function::variable.  */
    {"::", COLONCOLON, BINOP_END, 0},
    {"<<", LSH, BINOP_END, 0},
    {">>", RSH, BINOP_END, 0},
    {"==", EQUAL, BINOP_END, 0},
    {"!=", NOTEQUAL, BINOP_END, 0},
    {"<=", LEQ, BINOP_END, 0},
    {">=", GEQ, BINOP_END, 0},
    {".*", DOT_STAR, BINOP_END, FLAG_CXX}
  };

/* Identifier-like tokens.  Only type-specifiers than can appear in
   multi-word type names (for example 'double' can appear in 'long
   double') need to be listed here.  type-specifiers that are only ever
   single word (like 'float') are handled by the classify_name function.  */
static const struct token ident_tokens[] =
  {
    {"unsigned", UNSIGNED, OP_NULL, 0},
    {"template", TEMPLATE, OP_NULL, FLAG_CXX},
    {"volatile", VOLATILE_KEYWORD, OP_NULL, 0},
    {"struct", STRUCT, OP_NULL, 0},
    {"signed", SIGNED_KEYWORD, OP_NULL, 0},
    {"sizeof", SIZEOF, OP_NULL, 0},
    {"_Alignof", ALIGNOF, OP_NULL, 0},
    {"alignof", ALIGNOF, OP_NULL, FLAG_CXX},
    {"double", DOUBLE_KEYWORD, OP_NULL, 0},
    {"false", FALSEKEYWORD, OP_NULL, FLAG_CXX},
    {"class", CLASS, OP_NULL, FLAG_CXX},
    {"union", UNION, OP_NULL, 0},
    {"short", SHORT, OP_NULL, 0},
    {"const", CONST_KEYWORD, OP_NULL, 0},
    {"enum", ENUM, OP_NULL, 0},
    {"long", LONG, OP_NULL, 0},
    {"true", TRUEKEYWORD, OP_NULL, FLAG_CXX},
    {"int", INT_KEYWORD, OP_NULL, 0},
    {"new", NEW, OP_NULL, FLAG_CXX},
    {"delete", DELETE, OP_NULL, FLAG_CXX},
    {"operator", OPERATOR, OP_NULL, FLAG_CXX},

    {"and", ANDAND, BINOP_END, FLAG_CXX},
    {"and_eq", ASSIGN_MODIFY, BINOP_BITWISE_AND, FLAG_CXX},
    {"bitand", '&', OP_NULL, FLAG_CXX},
    {"bitor", '|', OP_NULL, FLAG_CXX},
    {"compl", '~', OP_NULL, FLAG_CXX},
    {"not", '!', OP_NULL, FLAG_CXX},
    {"not_eq", NOTEQUAL, BINOP_END, FLAG_CXX},
    {"or", OROR, BINOP_END, FLAG_CXX},
    {"or_eq", ASSIGN_MODIFY, BINOP_BITWISE_IOR, FLAG_CXX},
    {"xor", '^', OP_NULL, FLAG_CXX},
    {"xor_eq", ASSIGN_MODIFY, BINOP_BITWISE_XOR, FLAG_CXX},

    {"const_cast", CONST_CAST, OP_NULL, FLAG_CXX },
    {"dynamic_cast", DYNAMIC_CAST, OP_NULL, FLAG_CXX },
    {"static_cast", STATIC_CAST, OP_NULL, FLAG_CXX },
    {"reinterpret_cast", REINTERPRET_CAST, OP_NULL, FLAG_CXX },

    {"__typeof__", TYPEOF, OP_TYPEOF, 0 },
    {"__typeof", TYPEOF, OP_TYPEOF, 0 },
    {"typeof", TYPEOF, OP_TYPEOF, FLAG_SHADOW },
    {"__decltype", DECLTYPE, OP_DECLTYPE, FLAG_CXX },
    {"decltype", DECLTYPE, OP_DECLTYPE, FLAG_CXX | FLAG_SHADOW },

    {"typeid", TYPEID, OP_TYPEID, FLAG_CXX}
  };


static void
scan_macro_expansion (char *expansion)
{
  const char *copy;

  /* We'd better not be trying to push the stack twice.  */
  gdb_assert (! cpstate->macro_original_text);

  /* Copy to the obstack, and then free the intermediate
     expansion.  */
  copy = obstack_strdup (&cpstate->expansion_obstack, expansion);
  xfree (expansion);

  /* Save the old lexptr value, so we can return to it when we're done
     parsing the expanded text.  */
  cpstate->macro_original_text = pstate->lexptr;
  pstate->lexptr = copy;
}

static int
scanning_macro_expansion (void)
{
  return cpstate->macro_original_text != 0;
}

static void
finished_macro_expansion (void)
{
  /* There'd better be something to pop back to.  */
  gdb_assert (cpstate->macro_original_text);

  /* Pop back to the original text.  */
  pstate->lexptr = cpstate->macro_original_text;
  cpstate->macro_original_text = 0;
}

/* Return true iff the token represents a C++ cast operator.  */

static int
is_cast_operator (const char *token, int len)
{
  return (! strncmp (token, "dynamic_cast", len)
	  || ! strncmp (token, "static_cast", len)
	  || ! strncmp (token, "reinterpret_cast", len)
	  || ! strncmp (token, "const_cast", len));
}

/* The scope used for macro expansion.  */
static struct macro_scope *expression_macro_scope;

/* This is set if a NAME token appeared at the very end of the input
   string, with no whitespace separating the name from the EOF.  This
   is used only when parsing to do field name completion.  */
static int saw_name_at_eof;

/* This is set if the previously-returned token was a structure
   operator -- either '.' or ARROW.  */
static bool last_was_structop;

/* Depth of parentheses.  */
static int paren_depth;

/* Read one token, getting characters through lexptr.  */

static int
lex_one_token (struct parser_state *par_state, bool *is_quoted_name)
{
  int c;
  int namelen;
  unsigned int i;
  const char *tokstart;
  bool saw_structop = last_was_structop;

  last_was_structop = false;
  *is_quoted_name = false;

 retry:

  /* Check if this is a macro invocation that we need to expand.  */
  if (! scanning_macro_expansion ())
    {
      char *expanded = macro_expand_next (&pstate->lexptr,
                                          standard_macro_lookup,
                                          expression_macro_scope);

      if (expanded)
        scan_macro_expansion (expanded);
    }

  pstate->prev_lexptr = pstate->lexptr;

  tokstart = pstate->lexptr;
  /* See if it is a special token of length 3.  */
  for (i = 0; i < sizeof tokentab3 / sizeof tokentab3[0]; i++)
    if (strncmp (tokstart, tokentab3[i].oper, 3) == 0)
      {
	if ((tokentab3[i].flags & FLAG_CXX) != 0
	    && par_state->language ()->la_language != language_cplus)
	  break;

	pstate->lexptr += 3;
	yylval.opcode = tokentab3[i].opcode;
	return tokentab3[i].token;
      }

  /* See if it is a special token of length 2.  */
  for (i = 0; i < sizeof tokentab2 / sizeof tokentab2[0]; i++)
    if (strncmp (tokstart, tokentab2[i].oper, 2) == 0)
      {
	if ((tokentab2[i].flags & FLAG_CXX) != 0
	    && par_state->language ()->la_language != language_cplus)
	  break;

	pstate->lexptr += 2;
	yylval.opcode = tokentab2[i].opcode;
	if (tokentab2[i].token == ARROW)
	  last_was_structop = 1;
	return tokentab2[i].token;
      }

  switch (c = *tokstart)
    {
    case 0:
      /* If we were just scanning the result of a macro expansion,
         then we need to resume scanning the original text.
	 If we're parsing for field name completion, and the previous
	 token allows such completion, return a COMPLETE token.
         Otherwise, we were already scanning the original text, and
         we're really done.  */
      if (scanning_macro_expansion ())
        {
          finished_macro_expansion ();
          goto retry;
        }
      else if (saw_name_at_eof)
	{
	  saw_name_at_eof = 0;
	  return COMPLETE;
	}
      else if (par_state->parse_completion && saw_structop)
	return COMPLETE;
      else
        return 0;

    case ' ':
    case '\t':
    case '\n':
      pstate->lexptr++;
      goto retry;

    case '[':
    case '(':
      paren_depth++;
      pstate->lexptr++;
      if (par_state->language ()->la_language == language_objc
	  && c == '[')
	return OBJC_LBRAC;
      return c;

    case ']':
    case ')':
      if (paren_depth == 0)
	return 0;
      paren_depth--;
      pstate->lexptr++;
      return c;

    case ',':
      if (pstate->comma_terminates
          && paren_depth == 0
          && ! scanning_macro_expansion ())
	return 0;
      pstate->lexptr++;
      return c;

    case '.':
      /* Might be a floating point number.  */
      if (pstate->lexptr[1] < '0' || pstate->lexptr[1] > '9')
	{
	  last_was_structop = true;
	  goto symbol;		/* Nope, must be a symbol. */
	}
      /* FALL THRU.  */

    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
      {
	/* It's a number.  */
	int got_dot = 0, got_e = 0, toktype;
	const char *p = tokstart;
	int hex = input_radix > 10;

	if (c == '0' && (p[1] == 'x' || p[1] == 'X'))
	  {
	    p += 2;
	    hex = 1;
	  }
	else if (c == '0' && (p[1]=='t' || p[1]=='T' || p[1]=='d' || p[1]=='D'))
	  {
	    p += 2;
	    hex = 0;
	  }

	for (;; ++p)
	  {
	    /* This test includes !hex because 'e' is a valid hex digit
	       and thus does not indicate a floating point number when
	       the radix is hex.  */
	    if (!hex && !got_e && (*p == 'e' || *p == 'E'))
	      got_dot = got_e = 1;
	    /* This test does not include !hex, because a '.' always indicates
	       a decimal floating point number regardless of the radix.  */
	    else if (!got_dot && *p == '.')
	      got_dot = 1;
	    else if (got_e && (p[-1] == 'e' || p[-1] == 'E')
		     && (*p == '-' || *p == '+'))
	      /* This is the sign of the exponent, not the end of the
		 number.  */
	      continue;
	    /* We will take any letters or digits.  parse_number will
	       complain if past the radix, or if L or U are not final.  */
	    else if ((*p < '0' || *p > '9')
		     && ((*p < 'a' || *p > 'z')
				  && (*p < 'A' || *p > 'Z')))
	      break;
	  }
	toktype = parse_number (par_state, tokstart, p - tokstart,
				got_dot|got_e, &yylval);
        if (toktype == ERROR)
	  {
	    char *err_copy = (char *) alloca (p - tokstart + 1);

	    memcpy (err_copy, tokstart, p - tokstart);
	    err_copy[p - tokstart] = 0;
	    error (_("Invalid number \"%s\"."), err_copy);
	  }
	pstate->lexptr = p;
	return toktype;
      }

    case '@':
      {
	const char *p = &tokstart[1];

	if (par_state->language ()->la_language == language_objc)
	  {
	    size_t len = strlen ("selector");

	    if (strncmp (p, "selector", len) == 0
		&& (p[len] == '\0' || ISSPACE (p[len])))
	      {
		pstate->lexptr = p + len;
		return SELECTOR;
	      }
	    else if (*p == '"')
	      goto parse_string;
	  }

	while (ISSPACE (*p))
	  p++;
	size_t len = strlen ("entry");
	if (strncmp (p, "entry", len) == 0 && !c_ident_is_alnum (p[len])
	    && p[len] != '_')
	  {
	    pstate->lexptr = &p[len];
	    return ENTRY;
	  }
      }
      /* FALLTHRU */
    case '+':
    case '-':
    case '*':
    case '/':
    case '%':
    case '|':
    case '&':
    case '^':
    case '~':
    case '!':
    case '<':
    case '>':
    case '?':
    case ':':
    case '=':
    case '{':
    case '}':
    symbol:
      pstate->lexptr++;
      return c;

    case 'L':
    case 'u':
    case 'U':
      if (tokstart[1] != '"' && tokstart[1] != '\'')
	break;
      /* Fall through.  */
    case '\'':
    case '"':

    parse_string:
      {
	int host_len;
	int result = parse_string_or_char (tokstart, &pstate->lexptr,
					   &yylval.tsval, &host_len);
	if (result == CHAR)
	  {
	    if (host_len == 0)
	      error (_("Empty character constant."));
	    else if (host_len > 2 && c == '\'')
	      {
		++tokstart;
		namelen = pstate->lexptr - tokstart - 1;
		*is_quoted_name = true;

		goto tryname;
	      }
	    else if (host_len > 1)
	      error (_("Invalid character constant."));
	  }
	return result;
      }
    }

  if (!(c == '_' || c == '$' || c_ident_is_alpha (c)))
    /* We must have come across a bad character (e.g. ';').  */
    error (_("Invalid character '%c' in expression."), c);

  /* It's a name.  See how long it is.  */
  namelen = 0;
  for (c = tokstart[namelen];
       (c == '_' || c == '$' || c_ident_is_alnum (c) || c == '<');)
    {
      /* Template parameter lists are part of the name.
	 FIXME: This mishandles `print $a<4&&$a>3'.  */

      if (c == '<')
	{
	  if (! is_cast_operator (tokstart, namelen))
	    {
	      /* Scan ahead to get rest of the template specification.  Note
		 that we look ahead only when the '<' adjoins non-whitespace
		 characters; for comparison expressions, e.g. "a < b > c",
		 there must be spaces before the '<', etc. */
	      const char *p = find_template_name_end (tokstart + namelen);

	      if (p)
		namelen = p - tokstart;
	    }
	  break;
	}
      c = tokstart[++namelen];
    }

  /* The token "if" terminates the expression and is NOT removed from
     the input stream.  It doesn't count if it appears in the
     expansion of a macro.  */
  if (namelen == 2
      && tokstart[0] == 'i'
      && tokstart[1] == 'f'
      && ! scanning_macro_expansion ())
    {
      return 0;
    }

  /* For the same reason (breakpoint conditions), "thread N"
     terminates the expression.  "thread" could be an identifier, but
     an identifier is never followed by a number without intervening
     punctuation.  "task" is similar.  Handle abbreviations of these,
     similarly to breakpoint.c:find_condition_and_thread.  */
  if (namelen >= 1
      && (strncmp (tokstart, "thread", namelen) == 0
	  || strncmp (tokstart, "task", namelen) == 0)
      && (tokstart[namelen] == ' ' || tokstart[namelen] == '\t')
      && ! scanning_macro_expansion ())
    {
      const char *p = tokstart + namelen + 1;

      while (*p == ' ' || *p == '\t')
	p++;
      if (*p >= '0' && *p <= '9')
	return 0;
    }

  pstate->lexptr += namelen;

  tryname:

  yylval.sval.ptr = tokstart;
  yylval.sval.length = namelen;

  /* Catch specific keywords.  */
  std::string copy = copy_name (yylval.sval);
  for (i = 0; i < sizeof ident_tokens / sizeof ident_tokens[0]; i++)
    if (copy == ident_tokens[i].oper)
      {
	if ((ident_tokens[i].flags & FLAG_CXX) != 0
	    && par_state->language ()->la_language != language_cplus)
	  break;

	if ((ident_tokens[i].flags & FLAG_SHADOW) != 0)
	  {
	    struct field_of_this_result is_a_field_of_this;

	    if (lookup_symbol (copy.c_str (),
			       pstate->expression_context_block,
			       VAR_DOMAIN,
			       (par_state->language ()->la_language
			        == language_cplus ? &is_a_field_of_this
				: NULL)).symbol
		!= NULL)
	      {
		/* The keyword is shadowed.  */
		break;
	      }
	  }

	/* It is ok to always set this, even though we don't always
	   strictly need to.  */
	yylval.opcode = ident_tokens[i].opcode;
	return ident_tokens[i].token;
      }

  if (*tokstart == '$')
    return DOLLAR_VARIABLE;

  if (pstate->parse_completion && *pstate->lexptr == '\0')
    saw_name_at_eof = 1;

  yylval.ssym.stoken = yylval.sval;
  yylval.ssym.sym.symbol = NULL;
  yylval.ssym.sym.block = NULL;
  yylval.ssym.is_a_field_of_this = 0;
  return NAME;
}

/* An object of this type is pushed on a FIFO by the "outer" lexer.  */
struct token_and_value
{
  int token;
  YYSTYPE value;
};

/* A FIFO of tokens that have been read but not yet returned to the
   parser.  */
static std::vector<token_and_value> token_fifo;

/* Non-zero if the lexer should return tokens from the FIFO.  */
static int popping;

/* Temporary storage for c_lex; this holds symbol names as they are
   built up.  */
auto_obstack name_obstack;

/* Classify a NAME token.  The contents of the token are in `yylval'.
   Updates yylval and returns the new token type.  BLOCK is the block
   in which lookups start; this can be NULL to mean the global scope.
   IS_QUOTED_NAME is non-zero if the name token was originally quoted
   in single quotes.  IS_AFTER_STRUCTOP is true if this name follows
   a structure operator -- either '.' or ARROW  */

static int
classify_name (struct parser_state *par_state, const struct block *block,
	       bool is_quoted_name, bool is_after_structop)
{
  struct block_symbol bsym;
  struct field_of_this_result is_a_field_of_this;

  std::string copy = copy_name (yylval.sval);

  /* Initialize this in case we *don't* use it in this call; that way
     we can refer to it unconditionally below.  */
  memset (&is_a_field_of_this, 0, sizeof (is_a_field_of_this));

  bsym = lookup_symbol (copy.c_str (), block, VAR_DOMAIN,
			par_state->language ()->la_name_of_this
			? &is_a_field_of_this : NULL);

  if (bsym.symbol && SYMBOL_CLASS (bsym.symbol) == LOC_BLOCK)
    {
      yylval.ssym.sym = bsym;
      yylval.ssym.is_a_field_of_this = is_a_field_of_this.type != NULL;
      return BLOCKNAME;
    }
  else if (!bsym.symbol)
    {
      /* If we found a field of 'this', we might have erroneously
	 found a constructor where we wanted a type name.  Handle this
	 case by noticing that we found a constructor and then look up
	 the type tag instead.  */
      if (is_a_field_of_this.type != NULL
	  && is_a_field_of_this.fn_field != NULL
	  && TYPE_FN_FIELD_CONSTRUCTOR (is_a_field_of_this.fn_field->fn_fields,
					0))
	{
	  struct field_of_this_result inner_is_a_field_of_this;

	  bsym = lookup_symbol (copy.c_str (), block, STRUCT_DOMAIN,
				&inner_is_a_field_of_this);
	  if (bsym.symbol != NULL)
	    {
	      yylval.tsym.type = SYMBOL_TYPE (bsym.symbol);
	      return TYPENAME;
	    }
	}

      /* If we found a field on the "this" object, or we are looking
	 up a field on a struct, then we want to prefer it over a
	 filename.  However, if the name was quoted, then it is better
	 to check for a filename or a block, since this is the only
	 way the user has of requiring the extension to be used.  */
      if ((is_a_field_of_this.type == NULL && !is_after_structop) 
	  || is_quoted_name)
	{
	  /* See if it's a file name. */
	  struct symtab *symtab;

	  symtab = lookup_symtab (copy.c_str ());
	  if (symtab)
	    {
	      yylval.bval = BLOCKVECTOR_BLOCK (SYMTAB_BLOCKVECTOR (symtab),
					       STATIC_BLOCK);
	      return FILENAME;
	    }
	}
    }

  if (bsym.symbol && SYMBOL_CLASS (bsym.symbol) == LOC_TYPEDEF)
    {
      yylval.tsym.type = SYMBOL_TYPE (bsym.symbol);
      return TYPENAME;
    }

  /* See if it's an ObjC classname.  */
  if (par_state->language ()->la_language == language_objc && !bsym.symbol)
    {
      CORE_ADDR Class = lookup_objc_class (par_state->gdbarch (),
					   copy.c_str ());
      if (Class)
	{
	  struct symbol *sym;

	  yylval.theclass.theclass = Class;
	  sym = lookup_struct_typedef (copy.c_str (),
				       par_state->expression_context_block, 1);
	  if (sym)
	    yylval.theclass.type = SYMBOL_TYPE (sym);
	  return CLASSNAME;
	}
    }

  /* Input names that aren't symbols but ARE valid hex numbers, when
     the input radix permits them, can be names or numbers depending
     on the parse.  Note we support radixes > 16 here.  */
  if (!bsym.symbol
      && ((copy[0] >= 'a' && copy[0] < 'a' + input_radix - 10)
	  || (copy[0] >= 'A' && copy[0] < 'A' + input_radix - 10)))
    {
      YYSTYPE newlval;	/* Its value is ignored.  */
      int hextype = parse_number (par_state, copy.c_str (), yylval.sval.length,
				  0, &newlval);

      if (hextype == INT)
	{
	  yylval.ssym.sym = bsym;
	  yylval.ssym.is_a_field_of_this = is_a_field_of_this.type != NULL;
	  return NAME_OR_INT;
	}
    }

  /* Any other kind of symbol */
  yylval.ssym.sym = bsym;
  yylval.ssym.is_a_field_of_this = is_a_field_of_this.type != NULL;

  if (bsym.symbol == NULL
      && par_state->language ()->la_language == language_cplus
      && is_a_field_of_this.type == NULL
      && lookup_minimal_symbol (copy.c_str (), NULL, NULL).minsym == NULL)
    return UNKNOWN_CPP_NAME;

  return NAME;
}

/* Like classify_name, but used by the inner loop of the lexer, when a
   name might have already been seen.  CONTEXT is the context type, or
   NULL if this is the first component of a name.  */

static int
classify_inner_name (struct parser_state *par_state,
		     const struct block *block, struct type *context)
{
  struct type *type;

  if (context == NULL)
    return classify_name (par_state, block, false, false);

  type = check_typedef (context);
  if (!type_aggregate_p (type))
    return ERROR;

  std::string copy = copy_name (yylval.ssym.stoken);
  /* N.B. We assume the symbol can only be in VAR_DOMAIN.  */
  yylval.ssym.sym = cp_lookup_nested_symbol (type, copy.c_str (), block,
					     VAR_DOMAIN);

  /* If no symbol was found, search for a matching base class named
     COPY.  This will allow users to enter qualified names of class members
     relative to the `this' pointer.  */
  if (yylval.ssym.sym.symbol == NULL)
    {
      struct type *base_type = cp_find_type_baseclass_by_name (type,
							       copy.c_str ());

      if (base_type != NULL)
	{
	  yylval.tsym.type = base_type;
	  return TYPENAME;
	}

      return ERROR;
    }

  switch (SYMBOL_CLASS (yylval.ssym.sym.symbol))
    {
    case LOC_BLOCK:
    case LOC_LABEL:
      /* cp_lookup_nested_symbol might have accidentally found a constructor
	 named COPY when we really wanted a base class of the same name.
	 Double-check this case by looking for a base class.  */
      {
	struct type *base_type
	  = cp_find_type_baseclass_by_name (type, copy.c_str ());

	if (base_type != NULL)
	  {
	    yylval.tsym.type = base_type;
	    return TYPENAME;
	  }
      }
      return ERROR;

    case LOC_TYPEDEF:
      yylval.tsym.type = SYMBOL_TYPE (yylval.ssym.sym.symbol);
      return TYPENAME;

    default:
      return NAME;
    }
  internal_error (__FILE__, __LINE__, _("not reached"));
}

/* The outer level of a two-level lexer.  This calls the inner lexer
   to return tokens.  It then either returns these tokens, or
   aggregates them into a larger token.  This lets us work around a
   problem in our parsing approach, where the parser could not
   distinguish between qualified names and qualified types at the
   right point.

   This approach is still not ideal, because it mishandles template
   types.  See the comment in lex_one_token for an example.  However,
   this is still an improvement over the earlier approach, and will
   suffice until we move to better parsing technology.  */

static int
yylex (void)
{
  token_and_value current;
  int first_was_coloncolon, last_was_coloncolon;
  struct type *context_type = NULL;
  int last_to_examine, next_to_examine, checkpoint;
  const struct block *search_block;
  bool is_quoted_name, last_lex_was_structop;

  if (popping && !token_fifo.empty ())
    goto do_pop;
  popping = 0;

  last_lex_was_structop = last_was_structop;

  /* Read the first token and decide what to do.  Most of the
     subsequent code is C++-only; but also depends on seeing a "::" or
     name-like token.  */
  current.token = lex_one_token (pstate, &is_quoted_name);
  if (current.token == NAME)
    current.token = classify_name (pstate, pstate->expression_context_block,
				   is_quoted_name, last_lex_was_structop);
  if (pstate->language ()->la_language != language_cplus
      || (current.token != TYPENAME && current.token != COLONCOLON
	  && current.token != FILENAME))
    return current.token;

  /* Read any sequence of alternating "::" and name-like tokens into
     the token FIFO.  */
  current.value = yylval;
  token_fifo.push_back (current);
  last_was_coloncolon = current.token == COLONCOLON;
  while (1)
    {
      bool ignore;

      /* We ignore quoted names other than the very first one.
	 Subsequent ones do not have any special meaning.  */
      current.token = lex_one_token (pstate, &ignore);
      current.value = yylval;
      token_fifo.push_back (current);

      if ((last_was_coloncolon && current.token != NAME)
	  || (!last_was_coloncolon && current.token != COLONCOLON))
	break;
      last_was_coloncolon = !last_was_coloncolon;
    }
  popping = 1;

  /* We always read one extra token, so compute the number of tokens
     to examine accordingly.  */
  last_to_examine = token_fifo.size () - 2;
  next_to_examine = 0;

  current = token_fifo[next_to_examine];
  ++next_to_examine;

  name_obstack.clear ();
  checkpoint = 0;
  if (current.token == FILENAME)
    search_block = current.value.bval;
  else if (current.token == COLONCOLON)
    search_block = NULL;
  else
    {
      gdb_assert (current.token == TYPENAME);
      search_block = pstate->expression_context_block;
      obstack_grow (&name_obstack, current.value.sval.ptr,
		    current.value.sval.length);
      context_type = current.value.tsym.type;
      checkpoint = 1;
    }

  first_was_coloncolon = current.token == COLONCOLON;
  last_was_coloncolon = first_was_coloncolon;

  while (next_to_examine <= last_to_examine)
    {
      token_and_value next;

      next = token_fifo[next_to_examine];
      ++next_to_examine;

      if (next.token == NAME && last_was_coloncolon)
	{
	  int classification;

	  yylval = next.value;
	  classification = classify_inner_name (pstate, search_block,
						context_type);
	  /* We keep going until we either run out of names, or until
	     we have a qualified name which is not a type.  */
	  if (classification != TYPENAME && classification != NAME)
	    break;

	  /* Accept up to this token.  */
	  checkpoint = next_to_examine;

	  /* Update the partial name we are constructing.  */
	  if (context_type != NULL)
	    {
	      /* We don't want to put a leading "::" into the name.  */
	      obstack_grow_str (&name_obstack, "::");
	    }
	  obstack_grow (&name_obstack, next.value.sval.ptr,
			next.value.sval.length);

	  yylval.sval.ptr = (const char *) obstack_base (&name_obstack);
	  yylval.sval.length = obstack_object_size (&name_obstack);
	  current.value = yylval;
	  current.token = classification;

	  last_was_coloncolon = 0;

	  if (classification == NAME)
	    break;

	  context_type = yylval.tsym.type;
	}
      else if (next.token == COLONCOLON && !last_was_coloncolon)
	last_was_coloncolon = 1;
      else
	{
	  /* We've reached the end of the name.  */
	  break;
	}
    }

  /* If we have a replacement token, install it as the first token in
     the FIFO, and delete the other constituent tokens.  */
  if (checkpoint > 0)
    {
      current.value.sval.ptr
	= obstack_strndup (&cpstate->expansion_obstack,
			   current.value.sval.ptr,
			   current.value.sval.length);

      token_fifo[0] = current;
      if (checkpoint > 1)
	token_fifo.erase (token_fifo.begin () + 1,
			  token_fifo.begin () + checkpoint);
    }

 do_pop:
  current = token_fifo[0];
  token_fifo.erase (token_fifo.begin ());
  yylval = current.value;
  return current.token;
}

int
c_parse (struct parser_state *par_state)
{
  /* Setting up the parser state.  */
  scoped_restore pstate_restore = make_scoped_restore (&pstate);
  gdb_assert (par_state != NULL);
  pstate = par_state;

  c_parse_state cstate;
  scoped_restore cstate_restore = make_scoped_restore (&cpstate, &cstate);

  gdb::unique_xmalloc_ptr<struct macro_scope> macro_scope;

  if (par_state->expression_context_block)
    macro_scope
      = sal_macro_scope (find_pc_line (par_state->expression_context_pc, 0));
  else
    macro_scope = default_macro_scope ();
  if (! macro_scope)
    macro_scope = user_macro_scope ();

  scoped_restore restore_macro_scope
    = make_scoped_restore (&expression_macro_scope, macro_scope.get ());

  scoped_restore restore_yydebug = make_scoped_restore (&yydebug,
							parser_debug);

  /* Initialize some state used by the lexer.  */
  last_was_structop = false;
  saw_name_at_eof = 0;
  paren_depth = 0;

  token_fifo.clear ();
  popping = 0;
  name_obstack.clear ();

  return yyparse ();
}

#ifdef YYBISON

/* This is called via the YYPRINT macro when parser debugging is
   enabled.  It prints a token's value.  */

static void
c_print_token (FILE *file, int type, YYSTYPE value)
{
  switch (type)
    {
    case INT:
      parser_fprintf (file, "typed_val_int<%s, %s>",
		      TYPE_SAFE_NAME (value.typed_val_int.type),
		      pulongest (value.typed_val_int.val));
      break;

    case CHAR:
    case STRING:
      {
	char *copy = (char *) alloca (value.tsval.length + 1);

	memcpy (copy, value.tsval.ptr, value.tsval.length);
	copy[value.tsval.length] = '\0';

	parser_fprintf (file, "tsval<type=%d, %s>", value.tsval.type, copy);
      }
      break;

    case NSSTRING:
    case DOLLAR_VARIABLE:
      parser_fprintf (file, "sval<%s>", copy_name (value.sval).c_str ());
      break;

    case TYPENAME:
      parser_fprintf (file, "tsym<type=%s, name=%s>",
		      TYPE_SAFE_NAME (value.tsym.type),
		      copy_name (value.tsym.stoken).c_str ());
      break;

    case NAME:
    case UNKNOWN_CPP_NAME:
    case NAME_OR_INT:
    case BLOCKNAME:
      parser_fprintf (file, "ssym<name=%s, sym=%s, field_of_this=%d>",
		       copy_name (value.ssym.stoken).c_str (),
		       (value.ssym.sym.symbol == NULL
			? "(null)" : value.ssym.sym.symbol->print_name ()),
		       value.ssym.is_a_field_of_this);
      break;

    case FILENAME:
      parser_fprintf (file, "bval<%s>", host_address_to_string (value.bval));
      break;
    }
}

#endif

static void
yyerror (const char *msg)
{
  if (pstate->prev_lexptr)
    pstate->lexptr = pstate->prev_lexptr;

  error (_("A %s in expression, near `%s'."), msg, pstate->lexptr);
}
